#include <stdio.h>
#include "ibm.h"

int dlE=0;
#define CS (cs>>4)
#define DS (ds>>4)
#define ES (es>>4)
#define SS (ss>>4)

#define loadseg(a) ((a)<<4)

int keyboardtimer;
int tempc;
int bxcheck=0,spcheck=0;
unsigned short getword();
int count40=0;
int dosfunc;
unsigned char opcode;
int times=0;
unsigned short pc2,pc3;
int pit0=1;
int noint=0;
unsigned char cgamode,cgastat=0,cgacol;
int output=0;

int inint=0;
int ins=0;
unsigned char readmemb(unsigned long addr);
void writememb(unsigned long addr, unsigned char val);
unsigned short readmemw(unsigned long seg, unsigned long addr);
void writememw(unsigned long seg, unsigned short addr, unsigned short val);

unsigned char *ram,*rom,*vram,*vrom;

int ssegs;
unsigned short biosmask;

/*EA calculation*/

/*R/M - bits 0-2 - R/M   bits 3-5 - Reg   bits 6-7 - mod
  From 386 programmers manual :
r8(/r)                     AL    CL    DL    BL    AH    CH    DH    BH
r16(/r)                    AX    CX    DX    BX    SP    BP    SI    DI
r32(/r)                    EAX   ECX   EDX   EBX   ESP   EBP   ESI   EDI
/digit (Opcode)            0     1     2     3     4     5     6     7
REG =                      000   001   010   011   100   101   110   111
  Address
disp8 denotes an 8-bit displacement following the ModR/M byte, to be
sign-extended and added to the index. disp16 denotes a 16-bit displacement
following the ModR/M byte, to be added to the index. Default segment
register is SS for the effective addresses containing a BP index, DS for
other effective addresses.
            Ŀ Mod R/M ModR/M Values in HexadecimalĿ

[BX + SI]            000   00    08    10    18    20    28    30    38
[BX + DI]            001   01    09    11    19    21    29    31    39
[BP + SI]            010   02    0A    12    1A    22    2A    32    3A
[BP + DI]            011   03    0B    13    1B    23    2B    33    3B
[SI]             00  100   04    0C    14    1C    24    2C    34    3C
[DI]                 101   05    0D    15    1D    25    2D    35    3D
disp16               110   06    0E    16    1E    26    2E    36    3E
[BX]                 111   07    0F    17    1F    27    2F    37    3F

[BX+SI]+disp8        000   40    48    50    58    60    68    70    78
[BX+DI]+disp8        001   41    49    51    59    61    69    71    79
[BP+SI]+disp8        010   42    4A    52    5A    62    6A    72    7A
[BP+DI]+disp8        011   43    4B    53    5B    63    6B    73    7B
[SI]+disp8       01  100   44    4C    54    5C    64    6C    74    7C
[DI]+disp8           101   45    4D    55    5D    65    6D    75    7D
[BP]+disp8           110   46    4E    56    5E    66    6E    76    7E
[BX]+disp8           111   47    4F    57    5F    67    6F    77    7F

[BX+SI]+disp16       000   80    88    90    98    A0    A8    B0    B8
[BX+DI]+disp16       001   81    89    91    99    A1    A9    B1    B9
[BX+SI]+disp16       010   82    8A    92    9A    A2    AA    B2    BA
[BX+DI]+disp16       011   83    8B    93    9B    A3    AB    B3    BB
[SI]+disp16      10  100   84    8C    94    9C    A4    AC    B4    BC
[DI]+disp16          101   85    8D    95    9D    A5    AD    B5    BD
[BP]+disp16          110   86    8E    96    9E    A6    AE    B6    BE
[BX]+disp16          111   87    8F    97    9F    A7    AF    B7    BF

EAX/AX/AL            000   C0    C8    D0    D8    E0    E8    F0    F8
ECX/CX/CL            001   C1    C9    D1    D9    E1    E9    F1    F9
EDX/DX/DL            010   C2    CA    D2    DA    E2    EA    F2    FA
EBX/BX/BL            011   C3    CB    D3    DB    E3    EB    F3    FB
ESP/SP/AH        11  100   C4    CC    D4    DC    E4    EC    F4    FC
EBP/BP/CH            101   C5    CD    D5    DD    E5    ED    F5    FD
ESI/SI/DH            110   C6    CE    D6    DE    E6    EE    F6    FE
EDI/DI/BH            111   C7    CF    D7    DF    E7    EF    F7    FF

mod = 11 - register
      10 - address + 16 bit displacement
      01 - address + 8 bit displacement
      00 - address

reg = If mod=11,  (depending on data size, 16 bits/8 bits, 32 bits=extend 16 bit registers)
      0=AX/AL   1=CX/CL   2=DX/DL   3=BX/BL
      4=SP/AH   5=BP/CH   6=SI/DH   7=DI/BH

      Otherwise, LSB selects SI/DI (0=SI), NMSB selects BX/BP (0=BX), and MSB
      selects whether BX/BP are used at all (0=used).

      mod=00 is an exception though
      6=16 bit displacement only
      7=[BX]

      Usage varies with instructions.

      MOV AL,BL has ModR/M as C3, for example.
      mod=11, reg=0, r/m=3
      MOV uses reg as dest, and r/m as src.
      reg 0 is AL, reg 3 is BL

      If BP or SP are in address calc, seg is SS, else DS
*/

int cycles=0;
unsigned long easeg,eaaddr;
int rm,reg,mod,rmdat;

void fetchea()
{
        rmdat=readmemb(cs+pc); pc++;
        reg=(rmdat>>3)&7;
        mod=rmdat>>6;
        rm=rmdat&7;
        switch (mod)
        {
                case 0:
                switch (rm)
                {
                        case 0: eaaddr=BX+SI; easeg=ds; cycles-=7; break;
                        case 1: eaaddr=BX+DI; easeg=ds; cycles-=8; break;
                        case 2: eaaddr=BP+SI; easeg=ss; cycles-=8; break;
                        case 3: eaaddr=BP+DI; easeg=ss; cycles-=7; break;
                        case 4: eaaddr=SI; easeg=ds; cycles-=5; break;
                        case 5: eaaddr=DI; easeg=ds; cycles-=5; break;
                        case 6: eaaddr=getword(); easeg=ds; cycles-=6; break;
                        case 7: eaaddr=BX; easeg=ds; cycles-=5; break;
                }
                break;

                case 1:
                eaaddr=readmemb(cs+pc); pc++;
                if (eaaddr&0x80) eaaddr|=0xFF00;
//                if (output) printf("EAADDR %04X ",eaaddr);
                switch (rm)
                {
                        case 0: eaaddr+=BX+SI; easeg=ds; cycles-=11; break;
                        case 1: eaaddr+=BX+DI; easeg=ds; cycles-=12; break;
                        case 2: eaaddr+=BP+SI; easeg=ss; cycles-=12; break;
                        case 3: eaaddr+=BP+DI; easeg=ss; cycles-=11; break;
                        case 4: eaaddr+=SI; easeg=ds; cycles-=9; break;
                        case 5: eaaddr+=DI; easeg=ds; cycles-=9; break;
                        case 6: eaaddr+=BP; easeg=ss; cycles-=9; break;
                        case 7: eaaddr+=BX; easeg=ds; cycles-=9; break;
                }
//                if (output) printf("%04X %04X",eaaddr,BX);
                break;

                case 2:
                eaaddr=getword();
                switch (rm)
                {
                        case 0: eaaddr+=BX+SI; easeg=ds; cycles-=11; break;
                        case 1: eaaddr+=BX+DI; easeg=ds; cycles-=12; break;
                        case 2: eaaddr+=BP+SI; easeg=ss; cycles-=12; break;
                        case 3: eaaddr+=BP+DI; easeg=ss; cycles-=11; break;
                        case 4: eaaddr+=SI; easeg=ds; cycles-=9; break;
                        case 5: eaaddr+=DI; easeg=ds; cycles-=9; break;
                        case 6: eaaddr+=BP; easeg=ss; cycles-=9; break;
                        case 7: eaaddr+=BX; easeg=ds; cycles-=9; break;
                }
                break;
        }
        eaaddr&=0xFFFF;
}

inline unsigned char geteab()
{
        if (mod==3)
           return (rm&4)?regs[rm&3].b.h:regs[rm&3].b.l;
        cycles-=3;
        return readmemb(easeg+eaaddr);
}

inline unsigned short geteaw()
{
        if (mod==3)
           return regs[rm].w;
        cycles-=3;
        return readmemw(easeg,eaaddr);
}

inline unsigned short geteaw2()
{
        if (mod==3)
           return regs[rm].w;
        cycles-=2;
//        printf("Getting addr from %04X:%04X %05X\n",easeg,eaaddr+2,easeg+eaaddr+2);
        return readmemw(easeg,(eaaddr+2)&0xFFFF);
}

inline void seteab(unsigned char val)
{
        if (mod==3)
        {
                if (rm&4) regs[rm&3].b.h=val;
                else      regs[rm&3].b.l=val;
        }
        else
        {
                cycles-=2;
                writememb(easeg+eaaddr,val);
        }
}

inline void seteaw(unsigned short val)
{
        if (mod==3)
           regs[rm].w=val;
        else
        {
                cycles-=2;
                writememw(easeg,eaaddr,val);
//                writememb(easeg+eaaddr+1,val>>8);
        }
}

#define getr8(r)   ((r&4)?regs[r&3].b.h:regs[r&3].b.l)

#define setr8(r,v) if (r&4) regs[r&3].b.h=v; \
                   else     regs[r&3].b.l=v;


/*Flags*/
unsigned char znptable8[256];
unsigned short znptable16[65536];

void makeznptable()
{
      int c,d;
      for (c=0;c<256;c++)
      {
            d=0;
            if (c&1) d++;
            if (c&2) d++;
            if (c&4) d++;
            if (c&8) d++;
            if (c&16) d++;
            if (c&32) d++;
            if (c&64) d++;
            if (c&128) d++;
            if (d&1)
               znptable8[c]=0;
            else
               znptable8[c]=P_FLAG;
            if (!c) znptable8[c]|=Z_FLAG;
            if (c&0x80) znptable8[c]|=N_FLAG;
      }
      for (c=0;c<65536;c++)
      {
            d=0;
            if (c&1) d++;
            if (c&2) d++;
            if (c&4) d++;
            if (c&8) d++;
            if (c&16) d++;
            if (c&32) d++;
            if (c&64) d++;
            if (c&128) d++;
/*            if (c&0x100) d++;
            if (c&0x200) d++;
            if (c&0x400) d++;
            if (c&0x800) d++;
            if (c&0x1000) d++;
            if (c&0x2000) d++;
            if (c&0x4000) d++;
            if (c&0x8000) d++;*/
            if (d&1)
               znptable16[c]=0;
            else
               znptable16[c]=4;
            if (!c) znptable16[c]|=0x40;
            if (c&0x8000) znptable16[c]|=0x80;
      }
//      makemod1table();
}
int timetolive=0;
unsigned char readmemb(unsigned long addr)
{
        addr&=0xFFFFF;
        switch ((addr>>16)&0xF)
        {
                case 0: case 1: case 2: case 3: case 4:
                case 5: case 6: case 7: case 8: case 9:
                return ram[addr];
                case 11:
                if (addr&0x8000 && MDA)
                {
                        if (!HERCULES) return 0xFF;
                        if (!(hercctrl&2)) return 0xFF;
                }
                if (AMSTRAD) return readvram(addr);
                if (TANDY) return readtandyvram(addr);
                return vram[addr&0xFFFF];
                case 12: if (addr&0x8000) return 0x63;
                return 0x63;
                return vrom[addr&0x7FFF];
                case 15: return rom[addr&biosmask];
        }
        return 0xFF;
}

unsigned char cpu_readop(unsigned long addr) { return readmemb(addr); }
unsigned char cpu_readmem20(unsigned long addr) { return readmemb(addr); }

void writememb(unsigned long addr, unsigned char val)
{
        addr&=0xFFFFF;
//        if (addr==0x413) printf("Write 413 %02X %04X:%04X\n",val,cs>>4,pc);
//        if (addr==0x418) printf("Write 418 %02X %04X:%04X\n",val,cs>>4,pc);
//        if (addr==0xBBE8F) printf("Write BBE8F %02X %04X:%04X %04X\n",val,cs>>4,pc,ss>>4);
//        if (addr==0x40F) printf("Write 40F %02X %04X:%04X\n",val,cs>>4,pc);
//        if (addr==0x4B5) { printf("Write 4B5 %02X %04X:%04X\n",val,cs>>4,pc); output=0; }
//        if ((addr&0xFFFF)==0xBE84) printf("Write %05X %02X %04X:%04X %05X %04X %04X\n",addr,val,cs>>4,pc,oldds>>4,BX,BP);
//        if (addr==0x441) printf("Write 441 %02X %04X:%04X\n",val,cs>>4,pc);
        switch ((addr>>16)&0xF)
        {
                case 0: case 1: case 2: case 3: case 4:
                case 5: case 6: case 7: case 8: case 9:
                ram[addr]=val;
                return;
                case 11:
//                printf("VRAM write %05X %02X %04X:%04X %c\n",addr,val,cs>>4,pc,val);
                if (AMSTRAD)    writevram(addr,val);
                else if (TANDY) writetandyvram(addr,val);
                else            vram[addr&0xFFFF]=val;
                return;
        }
//        printf("Bad write addr %05X %02X\n",addr,val);
}

void cpu_writemem20(unsigned long addr, unsigned char val) { writememb(addr,val); }

unsigned short readmemw(unsigned long seg, unsigned long addr)
{
        if (!cpuspeed) cycles-=4;
//        if (addr==0x2DADE) printf("Read 2DADE\n");
        return readmemb(seg+addr)|(readmemb(seg+((addr+1)&0xFFFF))<<8);
}

void writememw(unsigned long seg, unsigned short addr, unsigned short val)
{
//        if (addr==0x2DADE) printf("Write 2DADE %04X %04X:%04X\n",val,cs>>4,pc);
//        if (addr==((ss+SP)-2) && val==0x3C) printf("Push 3C at %04X:%04X\n",cs>>4,pc);
//if (val==0x3C) printf("Write 3C to %05X at %04X:%04X\n",addr,cs>>4,pc);
//        if (addr==0x1044D) printf("%04X write %04X %04X:%04X\n",0x78,val,cs>>4,pc);
//        if (addr==0x2650+0x320) printf("%04X write %04X %04X:%04X\n",0x0320,val,cs>>4,pc);
//        if (addr==0x5A64+0x700) printf("%04X write %04X %04X:%04X\n",0x5A64,val,cs>>4,pc);
//        if (addr==0x5A7B+0x700) printf("%04X write %04X %04X:%04X\n",0x5A7B,val,cs>>4,pc);
//        if (addr==0x67FA+0x46CA) printf("%04X write %04X %04X:%04X\n",0x67FA,val,cs>>4,pc);
//        if (addr==0x413) { printf("413 write %04X %04X:%04X %i\n",val,cs>>4,pc,ins); output=0; }
//        if (addr==0x415) { printf("415 write %04X %04X:%04X %i\n",val,cs>>4,pc,ins); output=0; }
        if (!cpuspeed) cycles-=4;
        writememb(seg+addr,val);
        writememb(seg+((addr+1)&0xFFFF),val>>8);
}

unsigned short getword()
{
        pc+=2;
        return readmemw(cs,(pc-2));
}

void dumpregs()
{
        FILE *f;
        return;
        f=fopen("ram.dmp","wb");
        fwrite(ram,0xA0000,1,f);
        fclose(f);
        f=fopen("ram6.bin","wb");
        fwrite(ram+0x10100,0xA000,1,f);
        fclose(f);
        f=fopen("boot.bin","wb");
        fwrite(ram+0x7C00,0x200,1,f);
        fclose(f);
        f=fopen("ram7.bin","wb");
        fwrite(ram+0x11100,0x2000,1,f);
        fclose(f);
        f=fopen("ram8.bin","wb");
        fwrite(ram+0x3D210,0x200,1,f);
        fclose(f);        
        f=fopen("vram.dmp","wb");
        fwrite(vram,0x10000,1,f);
        fclose(f);
        f=fopen("bios.dmp","wb");
        fwrite(rom,0x10000,1,f);
        fclose(f);
        if (!times)
        {
                f=fopen("thing.dmp","wb");
                fwrite(ram+0x11E50,0x1000,1,f);
                fclose(f);
        }
        printf("AX=%04X BX=%04X CX=%04X DX=%04X DI=%04X SI=%04X BP=%04X SP=%04X\n",AX,BX,CX,DX,DI,SI,BP,SP);
        printf("PC=%04X CS=%04X DS=%04X ES=%04X SS=%04X FLAGS=%04X\n",pc,cs>>4,ds>>4,es>>4,ss>>4,flags);
        printf("%i ins\n",ins);
}

void resetx86()
{
//        i86_Reset();
        cs=0xFFFF0;
        pc=0;
        memset(ram,0,0xA0000);
}

void initmem()
{
        ram=malloc(0x100000);
        rom=malloc(0x10000);
        vram=malloc(0x40000);
        biosmask=65535;
        makeznptable();
}

int loadbios()
{
        FILE *f=NULL,*ff=NULL;
        int c;
        switch (romset)
        {
                case ROM_PC1512:
                f=fopen("roms/pc1512/40043.v1","rb");
                ff=fopen("roms/pc1512/40044.v1","rb");
                if (!f || !ff) break;
                for (c=0xC000;c<0x10000;c+=2)
                {
                        rom[c]=getc(f);
                        rom[c+1]=getc(ff);
                }
                fclose(ff);
                fclose(f);
                return 1;
                case ROM_PC200:
                f=fopen("roms/pc200/pc20v2.1","rb");
                ff=fopen("roms/pc200/pc20v2.0","rb");
                if (!f || !ff) break;
                for (c=0xC000;c<0x10000;c+=2)
                {
                        rom[c]=getc(f);
                        rom[c+1]=getc(ff);
                }
                fclose(ff);
                fclose(f);
                return 1;
                case ROM_TANDY:
                f=fopen("roms/tandy/tandy1t1.020","rb");
                if (!f) break;
                fread(rom,65536,1,f);
                fclose(f);
                return 1;
/*                case ROM_IBMPCJR:
                f=fopen("pcjr/bios.rom","rb");
                fread(rom+0xE000,8192,1,f);
                fclose(f);
                f=fopen("pcjr/basic.rom","rb");
                fread(rom+0x6000,32768,1,f);
                fclose(f);
                break;*/
                case ROM_IBMXT:
                f=fopen("roms/ibmxt/xt.rom","rb");
                if (!f)
                {
                        f=fopen("roms/ibmxt/xt050986.0","rb");
                        ff=fopen("roms/ibmxt/xt050986.1","rb");
                        if (!f || !ff) break;
                        for (c=0x0000;c<0x10000;c+=2)
                        {
                                rom[c]=getc(f);
                                rom[c+1]=getc(ff);
                        }
                        fclose(ff);
                        fclose(f);
                        return 1;
                }
                else
                {
                        fread(rom,65536,1,f);
                        fclose(f);
                        return 1;
                }
                break;
                case ROM_IBMPC:
                f=fopen("roms/ibmpc/pc102782.bin","rb");
                if (!f) break;
//                f=fopen("pc081682.bin","rb");
                fread(rom+0xE000,8192,1,f);
                fclose(f);
                f=fopen("roms/ibmpc/basicc11.f6","rb");
                if (!f) return 1; /*I don't really care if BASIC is there or not*/
                fread(rom+0x6000,8192,1,f);
                fclose(f);
                f=fopen("roms/ibmpc/basicc11.f8","rb");
                if (!f) break; /*But if some of it is there, then all of it must be*/
                fread(rom+0x8000,8192,1,f);
                fclose(f);
                f=fopen("roms/ibmpc/basicc11.fa","rb");
                if (!f) break;
                fread(rom+0xA000,8192,1,f);
                fclose(f);
                f=fopen("roms/ibmpc/basicc11.fc","rb");
                if (!f) break;
                fread(rom+0xC000,8192,1,f);
                fclose(f);
                return 1;
        }
        printf("Failed to load ROM!\n");
        if (f) fclose(f);
        if (ff) fclose(ff);
        return 0;
}

void setznp8(unsigned char val)
{
        flags&=~0xC4;
        flags|=znptable8[val];
}

#define setznp168 setznp16
void setznp16(unsigned short val)
{
        flags&=~0xC4;
//        flags|=((val&0x8000)?N_FLAG:((!val)?Z_FLAG:0));
//        flags|=(((znptable8[val&0xFF]&P_FLAG)==(znptable8[val>>8]&P_FLAG))?P_FLAG:0);
        flags|=znptable16[val];
}

/*void setznp168(unsigned short val)
{
        flags&=~0xC4;
        flags|=(znptable16[val]&0xC0)|(znptable8[val&0xFF]&4);
}*/

void setadd8(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a+(unsigned short)b;
        flags&=~0x8D5;
        flags|=znptable8[c&0xFF];
        if (c&0x100) flags|=C_FLAG;
        if (!((a^b)&0x80)&&((a^c)&0x80)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}
void setadd8nc(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a+(unsigned short)b;
        flags&=~0x8D4;
        flags|=znptable8[c&0xFF];
        if (!((a^b)&0x80)&&((a^c)&0x80)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}
void setadc8(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a+(unsigned short)b+tempc;
        flags&=~0x8D5;
        flags|=znptable8[c&0xFF];
        if (c&0x100) flags|=C_FLAG;
        if (!((a^b)&0x80)&&((a^c)&0x80)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}
void setadd16(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a+(unsigned long)b;
        flags&=~0x8D5;
        flags|=znptable16[c&0xFFFF];
        if (c&0x10000) flags|=C_FLAG;
        if (!((a^b)&0x8000)&&((a^c)&0x8000)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}
void setadd16nc(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a+(unsigned long)b;
        flags&=~0x8D4;
        flags|=znptable16[c&0xFFFF];
        if (!((a^b)&0x8000)&&((a^c)&0x8000)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}
void setadc16(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a+(unsigned long)b+tempc;
        flags&=~0x8D5;
        flags|=znptable16[c&0xFFFF];
        if (c&0x10000) flags|=C_FLAG;
        if (!((a^b)&0x8000)&&((a^c)&0x8000)) flags|=V_FLAG;
        if (((a&0xF)+(b&0xF))&0x10)      flags|=A_FLAG;
}

void setsub8(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a-(unsigned short)b;
        flags&=~0x8D5;
        flags|=znptable8[c&0xFF];
        if (c&0x100) flags|=C_FLAG;
        if ((a^b)&(a^c)&0x80) flags|=V_FLAG;
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}
void setsub8nc(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a-(unsigned short)b;
        flags&=~0x8D4;
        flags|=znptable8[c&0xFF];
        if ((a^b)&(a^c)&0x80) flags|=V_FLAG;
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}
void setsbc8(unsigned char a, unsigned char b)
{
        unsigned short c=(unsigned short)a-(((unsigned short)b)+tempc);
        flags&=~0x8D5;
        flags|=znptable8[c&0xFF];
        if (c&0x100) flags|=C_FLAG;
        if ((a^b)&(a^c)&0x80) flags|=V_FLAG;
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}
void setsub16(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a-(unsigned long)b;
        flags&=~0x8D5;
        flags|=znptable16[c&0xFFFF];
        if (c&0x10000) flags|=C_FLAG;
        if ((a^b)&(a^c)&0x8000) flags|=V_FLAG;
//        if (output) printf("%04X %04X %i\n",a^b,a^c,flags&V_FLAG);
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}
void setsub16nc(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a-(unsigned long)b;
        flags&=~0x8D4;
        flags|=(znptable16[c&0xFFFF]&~4);
        flags|=(znptable8[c&0xFF]&4);
        if ((a^b)&(a^c)&0x8000) flags|=V_FLAG;
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}
void setsbc16(unsigned short a, unsigned short b)
{
        unsigned long c=(unsigned long)a-(((unsigned long)b)+tempc);
        flags&=~0x8D5;
        flags|=(znptable16[c&0xFFFF]&~4);
        flags|=(znptable8[c&0xFF]&4);
        if (c&0x10000) flags|=C_FLAG;
        if ((a^b)&(a^c)&0x8000) flags|=V_FLAG;
        if (((a&0xF)-(b&0xF))&0x10)      flags|=A_FLAG;
}

unsigned char lpt2dat;
unsigned char inb(unsigned short port)
{
        unsigned char temp;
//        if ((port&0x3F0)==0x3D0) printf("Video access read %03X %04X:%04X\n",port,cs>>4,pc);
//        if (cs<0xF0000) printf("IN %04X\n",port);
//        if (port!=0x41 && port!=0x43) printf("IN %04X\n",port);
        switch (port)
        {
                case 0x00: case 0x01: case 0x02: case 0x03: /*DMA*/
                case 0x04: case 0x05: case 0x06: case 0x07:
                case 0x08: case 0x09: case 0x0A: case 0x0B:
                case 0x0C: case 0x0D: case 0x0E: case 0x0F:
                return readdma(port);
                case 0x20: case 0x21: /*PIC*/
                return readpic(port);
                case 0x40: case 0x41: case 0x42: case 0x43: /*PIT*/
                temp=readpit(port);
//                printf("Reading %02X from %04X\n",temp,port);
                return temp;
                case 0x60: case 0x61: case 0x62: case 0x63: case 0x64: case 0x65: /*PPI*/
                return readppi(port);
                case 0x70: case 0x71: /*NVR*/
                return readnvr(port);
                case 0x78: case 0x7A: /*Amstrad mouse*/
                return readmouse(port);
                case 0xA0:
//                        printf("Read A0 %04X:%04X\n",cs>>4,pc);
                return 0;
                case 0x201: /*Joystick?*/
                return 0xFF;
                case 0x210: case 0x211: case 0x212: case 0x213: /*XT expansion*/
                case 0x214: case 0x215: case 0x216: case 0x217:
                return 0;
                case 0x220: case 0x221: case 0x222: case 0x223: /*Gameblaster*/
                if (GAMEBLASTER) return readcms(port);
                return 0xFF;
                case 0x278: /*LPT?*/
                return 0;
                case 0x2CB: case 0x2D2: /*??*/
                return 0;
                case 0x378: /*LPT2*/
//                printf("Read LPT2 %04X:%04X\n",cs>>4,pc);
                return lpt2dat;
                case 0x379:
                if (romset==ROM_PC1512) return 7;
                return 0;
                case 0x37A:
                return 0x80;
                case 0x388: case 0x389: /*Adlib*/
                if (ADLIB) return readadlib(port);
                return 0xFF;
                        
                case 0x3B4: case 0x3B5: /*MDA*/
                return readcrtcm(port);
                case 0x3D4: case 0x3D5: /*CGA CRTC*/
                if (MDA) return 0xFF;
                return readcrtc(port);
                case 0x3BA: //case 0x3DA:
                if (HERCULES) return cgastat|(rand()&1)|(cgastat<<4);
                return cgastat|(rand()&1);
                case 0x3DA: if (MDA) return 0xFF;
//                printf("Read 3DA %04X:%04X %i %02X\n",cs>>4,pc,ins,BL);
                cgastat^=1;
                return cgastat;
                case 0x3BC: /*LPT1*/
                return 0;
                case 0x3DE:
//                        printf("Read 3DE %04X:%04X\n",cs>>4,pc);
                return 0x00;
//                case 0x3FA: /*case 0x2FA:*/ /*Serial*/
//                return 0xFF;
                case 0x3F0: case 0x3F1: case 0x3F2: case 0x3F3: /*FDC*/
                case 0x3F4: case 0x3F5: case 0x3F6: case 0x3F7:
                return readfdc(port);
                case 0x2F8: case 0x2F9: case 0x2FA: case 0x2FB:
                case 0x2FC: case 0x2FD: case 0x2FE: case 0x2FF:
                if (TANDY) return readserial(port);
                return 0xFF;
                case 0x3F8: case 0x3F9: case 0x3FA: case 0x3FB:
                case 0x3FC: case 0x3FD: case 0x3FE: case 0x3FF:
                if (!TANDY) return readserial(port);
                return 0xFF;
        }
//        printf("Bad IN port %04X %04X:%04X\n",port,cs>>4,pc);
        return 0;
        dumpregs();
        exit(-1);
}

unsigned char cpu_readport(unsigned long port) { return inb(port); }

int speshul;

void outb(unsigned short port, unsigned char val)
{
//        if ((port&0x3F0)==0x3D0) printf("Video access %03X %02X %04X:%04X\n",port,val,cs>>4,pc);
//        if (cs<0xF0000) printf("OUT %04X\n",port);
//        if (port!=0x41 && port!=0x43) printf("OUT %04X %02X\n",port,val);
        switch (port)
        {
                case 0x00: case 0x01: case 0x02: case 0x03: /*DMA*/
                case 0x04: case 0x05: case 0x06: case 0x07:
                case 0x08: case 0x09: case 0x0A: case 0x0B:
                case 0x0C: case 0x0D: case 0x0E: case 0x0F:
                writedma(port,val);
                return;
                case 0x20: case 0x21: /*PIC*/
                writepic(port,val);
                return;
                case 0x40: case 0x41: case 0x42: case 0x43: /*PIT*/
                writepit(port,val);
                return;
                case 0x60: case 0x61: case 0x62: case 0x63: case 0x64: case 0x65: /*PPI*/
                writeppi(port,val);
                return;
                case 0x70: case 0x71: /*NVR*/
                writenvr(port,val);
                return;
                case 0x78: case 0x7A: /*Amstrad mouse*/
                writemouse(port,val);
                return;
                case 0x80: case 0x81: case 0x82: case 0x83: /*DMA paging*/
                case 0x84: case 0x85: case 0x86: case 0x87:
                writepage(port,val);
                return;
                case 0xC0: case 0xC1:
                if (TANDY) writepsg(val);
                return;
                case 0x210: case 0x211: case 0x212: case 0x213: /*XT expansion*/
                case 0x214: case 0x215: case 0x216: case 0x217:
                return;
                case 0x220: case 0x221: case 0x222: case 0x223: /*Gameblaster*/
                if (GAMEBLASTER) writecms(port,val);
                return;
                case 0x3F0: case 0x3F1: case 0x3F2: case 0x3F3: /*FDC*/
                case 0x3F4: case 0x3F5: case 0x3F6: case 0x3F7:
                writefdc(port,val);
                return;
                case 0x2D2: /*??*/
                return;
                case 0x378: lpt2dat=val; return;
                case 0x388: case 0x389: /*Adlib*/
                if (ADLIB) writeadlib(port,val);
                return;
                case 0x3B4: case 0x3B5: /*MDA CRTC*/
                writecrtcm(port,val);
                return;
                case 0x3B8: case 0x3BF:
                writemda(port,val);
                return;
                case 0x3D4: case 0x3D5: /*CGA CRTC*/
                writecrtc(port,val);
                return;
//                case 0x3DA: case 0x3DE: /*PCjr/Tandy video*/
//                writearray(port,val);
//                return;
                case 0x3D8:
//                        printf("Write CGAMODE %02X %04X:%04X\n",val,cs>>4,pc);
                cgamode=val;
                return;
                case 0x3D9:
                cgacol=val;
//                printf("CGACOL %02X\n",val);
                return;
                case 0x3DA: case 0x3DD: case 0x3DE: case 0x3DF:
                if (AMSTRAD) writeams(port,val);
                if (TANDY) writetandy(port,val);
                        return;
                case 0x2F8: case 0x2F9: case 0x2FA: case 0x2FB:
                case 0x2FC: case 0x2FD: case 0x2FE: case 0x2FF:
                if (TANDY) writeserial(port,val);
                return;
                case 0x3F8: case 0x3F9: case 0x3FA: case 0x3FB:
                case 0x3FC: case 0x3FD: case 0x3FE: case 0x3FF:
                if (!TANDY) writeserial(port,val);
                return;
//                case 0x3DE:
//                        printf("3DE write %02X\n",val);
//                speshul=val&1;
//                return;
        }
//        printf("OUT %04X %02X %04X:%04X\n",port,val,cs>>4,pc);
}

int firstrepcycle=1;
void cpu_writeport(unsigned long port, unsigned char val) { outb(port,val); }
void rep(int fv)
{
        unsigned char temp;
        int c=CX;
        unsigned char temp2;
        unsigned short tempw,tempw2;
        unsigned short ipc=pc-1;
        int changeds=0;
        unsigned long oldds;
        startrep:
        temp=readmemb(cs+pc); pc++;
//        if (output) printf("REP %02X %04X\n",temp,ipc);
        switch (temp)
        {
                case 0x08:
                pc=ipc+1;
                break;
                case 0x26: /*ES:*/
                oldds=ds;
                ds=es;
                changeds=1;
                goto startrep;
                break;
                case 0x2E: /*CS:*/
                oldds=ds;
                ds=cs;
                changeds=1;
                goto startrep;
                break;
                case 0x6E: /*REP OUTSB*/
                if (c>0)
                {
                        temp2=readmemb(ds+SI);
                        outb(DX,temp2);
                        if (flags&D_FLAG) SI--;
                        else              SI++;
                        c--;
                        cycles-=5;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xA4: /*REP MOVSB*/
                if (c>0)
                {
                        temp2=readmemb(ds+SI);
                        writememb(es+DI,temp2);
//                        if (output) printf("Moved %02X %c from %04X:%04X to %04X:%04X\n",temp2,temp2,ds>>4,SI,es>>4,DI);
                        if (flags&D_FLAG) { DI--; SI--; }
                        else              { DI++; SI++; }
                        c--;
                        cycles-=17;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
//                }
                break;
                case 0xA5: /*REP MOVSW*/
                if (c>0)
                {
                        tempw=readmemw(ds,SI);
                        writememw(es,DI,tempw);
                        if (flags&D_FLAG) { DI-=2; SI-=2; }
                        else              { DI+=2; SI+=2; }
                        c--;
                        cycles-=17;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
//                }
                break;
                case 0xA6: /*REP CMPSB*/
                if (fv) flags|=Z_FLAG;
                else    flags&=~Z_FLAG;
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))
                {
                        temp=readmemb(ds+SI);
                        temp2=readmemb(es+DI);
//                        printf("CMPSB %c %c %i %05X %05X %04X:%04X\n",temp,temp2,c,ds+SI,es+DI,cs>>4,pc);
                        if (flags&D_FLAG) { DI--; SI--; }
                        else              { DI++; SI++; }
                        c--;
                        cycles-=30;
                        setsub8(temp,temp2);
                }
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0))) { pc=ipc; firstrepcycle=0; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xA7: /*REP CMPSW*/
                if (fv) flags|=Z_FLAG;
                else    flags&=~Z_FLAG;
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))
                {
                        tempw=readmemw(ds,SI);
                        tempw2=readmemw(es,DI);
                        if (flags&D_FLAG) { DI-=2; SI-=2; }
                        else              { DI+=2; SI+=2; }
                        c--;
                        cycles-=30;
                        setsub16(tempw,tempw2);
                }
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0))) { pc=ipc; firstrepcycle=0; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xAA: /*REP STOSB*/
                if (c>0)
                {
                        writememb(es+DI,AL);
                        if (flags&D_FLAG) DI--;
                        else              DI++;
                        c--;
                        cycles-=10;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xAB: /*REP STOSW*/
                if (c>0)
                {
                        writememw(es,DI,AX);
                        if (flags&D_FLAG) DI-=2;
                        else              DI+=2;
                        c--;
                        cycles-=10;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xAC: /*REP LODSB*/
                if (c>0)
                {
                        temp2=readmemb(ds+SI);
                        if (flags&D_FLAG) SI--;
                        else              SI++;
                        c--;
                        cycles-=4;
                }
                if (c>0) { firstrepcycle=0; pc=ipc; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                case 0xAE: /*REP SCASB*/
                if (fv) flags|=Z_FLAG;
                else    flags&=~Z_FLAG;
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))
                {
                        temp2=readmemb(es+DI);
//                        if (output) printf("SCASB %02X %c %02X %05X  ",temp2,temp2,AL,es+DI);
                        setsub8(AL,temp2);
//                        if (output && flags&Z_FLAG) printf("Match %02X %02X\n",AL,temp2);
                        if (flags&D_FLAG) DI--;
                        else              DI++;
                        c--;
                        cycles-=15;
                }
//if (output)                printf("%i %i %i %i\n",c,(c>0),(fv==((flags&Z_FLAG)?1:0)),((c>0) && (fv==((flags&Z_FLAG)?1:0))));
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))  { pc=ipc; firstrepcycle=0; if (ssegs) ssegs++; }
                else firstrepcycle=1;
//                cycles-=120;
                break;
                case 0xAF: /*REP SCASW*/
                if (fv) flags|=Z_FLAG;
                else    flags&=~Z_FLAG;
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))
                {
                        tempw=readmemw(es,DI);
                        setsub16(AX,tempw);
                        if (flags&D_FLAG) DI-=2;
                        else              DI+=2;
                        c--;
                        cycles-=15;
                }
                if ((c>0) && (fv==((flags&Z_FLAG)?1:0)))  { pc=ipc; firstrepcycle=0; if (ssegs) ssegs++; }
                else firstrepcycle=1;
                break;
                default:
                        pc=ipc;
                        cycles-=20;
//                printf("Bad REP %02X\n",temp);
//                dumpregs();
//                exit(-1);
        }
        CX=c;
        if (changeds) ds=oldds;
}

void clockstuff(int cycdiff)
{
                if (pit0 && !pit.delay[0]) pit.c[0]-=cycdiff;
                if (!pit.delay[1])         pit.c[1]-=cycdiff;
                if (!pit.delay[2])         pit.c[2]-=cycdiff;
                if (pit.delay[0]) pit.delay[0]--;
                if (pit.delay[1]) pit.delay[1]--;
                if (pit.delay[2]) pit.delay[2]--;
                if ((pit.c[0]<1)||(pit.c[1]<1)||(pit.c[2]<1)) pollpit();
                if (disctime)
                {
                        disctime-=cycdiff;
                        if (disctime<=0)
                        {
                                disctime=0;
                                polldisc();
                        }
                }
}
unsigned long old8,old82;
unsigned short oldpc,oldcs;
int inhlt=0;
unsigned short lastpc,lastcs;
int firstrepcycle;
int skipnextprint=0;
//#if 0
void execx86(int cycs)
{
        unsigned char temp,temp2;
        unsigned short addr,tempw,tempw2;
        signed char offset;
        int tempws;
        unsigned long templ;
        int c,cycdiff;
        FILE *f;
        cycles+=cycs;
//        i86_Execute(cycs);
//        return;
        while (cycles>0)
        {
                old82=old8;
                old8=oldpc|(oldcs<<16);
//                if (pc==0x96B && cs==0x9E040) { printf("Hit it\n"); output=1; timetolive=150; }
//                if (pc<0x8000) printf("%04X : %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %02X %04X %i\n",pc,AX,BX,CX,DX,cs>>4,ds>>4,es>>4,ss>>4,DI,SI,BP,SP,opcode,flags,disctime);
                cycdiff=cycles;
                oldcs=cs>>4;
                oldpc=pc;
                opcode=readmemb(cs+pc);
                tempc=flags&C_FLAG;
//                if (output) printf("%04X:%04X : %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %02X %04X\n",cs>>4,pc,AX,BX,CX,DX,cs>>4,ds>>4,es>>4,ss>>4,DI,SI,BP,SP,opcode,flags&~0x200,rmdat);
                if (output && /*cs<0xF0000 && */!ssegs)//opcode!=0x26 && opcode!=0x36 && opcode!=0x2E && opcode!=0x3E)
                {
                        if ((opcode!=0xF2 && opcode!=0xF3) || firstrepcycle)
                        {
                                if (!skipnextprint) printf("%04X:%04X : %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %04X %02X %04X\n",cs>>4,pc,AX,BX,CX,DX,cs>>4,ds>>4,es>>4,ss>>4,DI,SI,BP,SP,opcode,flags,rmdat);
                                skipnextprint=0;
//                                ins++;
/*                                if (ins==50000)
                                {
                                        dumpregs();
                                        exit(-1);
                                }*/
/*                                if (ins==500000)
                                {
                                        dumpregs();
                                        exit(-1);
                                }*/
                        }
                }
                pc++;
                inhlt=0;
//                if (ins==500000) { dumpregs(); exit(0); }*/
                switch (opcode)
                {
                        case 0x00: /*ADD 8,reg*/
                        fetchea();
/*                        if (!rmdat) pc--;
                        if (!rmdat)
                        {
                                printf("Crashed\n");
//                                clear_keybuf();
//                                readkey();
                                dumpregs();
                                exit(-1);
                        }*/
                        temp=geteab();
                        setadd8(temp,getr8(reg));
                        temp+=getr8(reg);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x01: /*ADD 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        setadd16(tempw,regs[reg].w);
                        tempw+=regs[reg].w;
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x02: /*ADD reg,8*/
                        fetchea();
                        temp=geteab();
                        setadd8(getr8(reg),temp);
                        setr8(reg,getr8(reg)+temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x03: /*ADD reg,16*/
                        fetchea();
                        tempw=geteaw();
                        setadd16(regs[reg].w,tempw);
                        regs[reg].w+=tempw;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x04: /*ADD AL,#8*/
                        temp=readmemb(cs+pc); pc++;
                        setadd8(AL,temp);
                        AL+=temp;
                        cycles-=4;
                        break;
                        case 0x05: /*ADD AX,#16*/
                        tempw=getword();
                        setadd16(AX,tempw);
                        AX+=tempw;
                        cycles-=4;
                        break;

                        case 0x06: /*PUSH ES*/
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),ES);
                        SP-=2;
                        cycles-=14;
                        break;
                        case 0x07: /*POP ES*/
                        if (ssegs) ss=oldss;
                        tempw=readmemw(ss,SP);
                        templ=loadseg(tempw);
                        if (templ!=0xFFFFFFFF)
                        {
                                es=templ;
//                                ES=tempw;
                        }
//                        es=ES<<4;
                        SP+=2;
                        cycles-=12;
                        break;

                        case 0x08: /*OR 8,reg*/
                        fetchea();
                        temp=geteab();
                        temp|=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x09: /*OR 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw|=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x0A: /*OR reg,8*/
                        fetchea();
                        temp=geteab();
                        temp|=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        setr8(reg,temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x0B: /*OR reg,16*/
                        fetchea();
                        tempw=geteaw();
                        tempw|=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        regs[reg].w=tempw;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x0C: /*OR AL,#8*/
                        AL|=readmemb(cs+pc); pc++;
                        setznp8(AL);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;
                        case 0x0D: /*OR AX,#16*/
                        AX|=getword();
                        setznp16(AX);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;

                        case 0x0E: /*PUSH CS*/
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),CS);
                        SP-=2;
                        cycles-=14;
                        break;

                        case 0x10: /*ADC 8,reg*/
                        fetchea();
                        temp=geteab();
                        temp2=getr8(reg);
                        setadc8(temp,temp2);
                        temp+=temp2+tempc;
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x11: /*ADC 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=regs[reg].w;
                        setadc16(tempw,tempw2);
                        tempw+=tempw2+tempc;
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x12: /*ADC reg,8*/
                        fetchea();
                        temp=geteab();
                        setadc8(getr8(reg),temp);
                        setr8(reg,getr8(reg)+temp+tempc);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x13: /*ADC reg,16*/
                        fetchea();
                        tempw=geteaw();
                        setadc16(regs[reg].w,tempw);
                        regs[reg].w+=tempw+tempc;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x14: /*ADC AL,#8*/
                        tempw=readmemb(cs+pc); pc++;
                        setadc8(AL,tempw);
                        AL+=tempw+tempc;
                        cycles-=4;
                        break;
                        case 0x15: /*ADC AX,#16*/
                        tempw=getword();
                        setadc16(AX,tempw);
                        AX+=tempw+tempc;
                        cycles-=4;
                        break;

                        case 0x16: /*PUSH SS*/
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),SS);
                        SP-=2;
                        cycles-=14;
                        break;
                        case 0x17: /*POP SS*/
                        if (ssegs) ss=oldss;
                        tempw=readmemw(ss,SP);
                        templ=loadseg(tempw);
                        if (templ!=0xFFFFFFFF)
                        {
                                ss=templ;
//                                SS=tempw;
                        }
//                        ss=SS<<4;
                        SP+=2;
                        noint=1;
                        cycles-=12;
//                        output=1;
                        break;

                        case 0x18: /*SBB 8,reg*/
                        fetchea();
                        temp=geteab();
                        temp2=getr8(reg);
                        setsbc8(temp,temp2);
                        temp-=(temp2+tempc);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x19: /*SBB 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=regs[reg].w;
//                        printf("%04X:%04X SBB %04X-%04X,%i\n",cs>>4,pc,tempw,tempw2,tempc);
                        setsbc16(tempw,tempw2);
                        tempw-=(tempw2+tempc);
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x1A: /*SBB reg,8*/
                        fetchea();
                        temp=geteab();
                        setsbc8(getr8(reg),temp);
                        setr8(reg,getr8(reg)-(temp+tempc));
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x1B: /*SBB reg,16*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=regs[reg].w;
//                        printf("%04X:%04X SBB %04X-%04X,%i\n",cs>>4,pc,tempw,tempw2,tempc);
                        setsbc16(tempw2,tempw);
                        tempw2-=(tempw+tempc);
                        regs[reg].w=tempw2;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x1C: /*SBB AL,#8*/
                        temp=readmemb(cs+pc); pc++;
                        setsbc8(AL,temp);
                        AL-=(temp+tempc);
                        cycles-=4;
                        break;
                        case 0x1D: /*SBB AX,#16*/
                        tempw=getword();
                        setsbc16(AX,tempw);
                        AX-=(tempw+tempc);
                        cycles-=4;
                        break;

                        case 0x1E: /*PUSH DS*/
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),DS);
                        SP-=2;
                        cycles-=14;
                        break;
                        case 0x1F: /*POP DS*/
                        if (ssegs) ss=oldss;
                        tempw=readmemw(ss,SP);
                        templ=loadseg(tempw);
                        if (templ!=0xFFFFFFFF)
                        {
                                ds=templ;
//                                DS=tempw;
                        }
//                        if (templ!=0xFFFFFFFF) ds=templ;
//                        ds=DS<<4;
                        if (ssegs) oldds=ds;
//                        printf("DS now %04X %04X:%04X\n",ds>>4,cs>>4,pc);
                        SP+=2;
                        cycles-=12;
                        break;

                        case 0x20: /*AND 8,reg*/
                        fetchea();
                        temp=geteab();
                        temp&=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x21: /*AND 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw&=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x22: /*AND reg,8*/
                        fetchea();
                        temp=geteab();
                        temp&=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        setr8(reg,temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x23: /*AND reg,16*/
                        fetchea();
                        tempw=geteaw();
                        tempw&=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        regs[reg].w=tempw;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x24: /*AND AL,#8*/
                        AL&=readmemb(cs+pc); pc++;
                        setznp8(AL);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;
                        case 0x25: /*AND AX,#16*/
                        AX&=getword();
                        setznp16(AX);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;

                        case 0x26: /*ES:*/
                        oldss=ss;
                        oldds=ds;
                        ds=ss=es;
                        ssegs=2;
                        cycles-=4;
                        break;

                        case 0x27: /*DAA*/
                        if ((flags&A_FLAG) || ((AL&0xF)>9))
                        {
                                AL+=6;
                                flags|=A_FLAG;
                        }
                        else
                           flags&=~A_FLAG;
                        if ((flags&C_FLAG) || (AL>0x9F))
                        {
                                AL+=0x60;
                                flags|=C_FLAG;
                        }
                        else
                           flags&=~C_FLAG;
                        setznp8(AL);
                        cycles-=4;
                        break;

                        case 0x28: /*SUB 8,reg*/
                        fetchea();
                        temp=geteab();
                        setsub8(temp,getr8(reg));
                        temp-=getr8(reg);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x29: /*SUB 16,reg*/
                        fetchea();
                        tempw=geteaw();
//                        printf("%04X:%04X  %04X-%04X\n",cs>>4,pc,tempw,regs[reg].w);
                        setsub16(tempw,regs[reg].w);
                        tempw-=regs[reg].w;
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x2A: /*SUB reg,8*/
                        fetchea();
                        temp=geteab();
                        setsub8(getr8(reg),temp);
                        setr8(reg,getr8(reg)-temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x2B: /*SUB reg,16*/
                        fetchea();
                        tempw=geteaw();
//                        printf("%04X:%04X  %04X-%04X\n",cs>>4,pc,regs[reg].w,tempw);
                        setsub16(regs[reg].w,tempw);
                        regs[reg].w-=tempw;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x2C: /*SUB AL,#8*/
                        temp=readmemb(cs+pc); pc++;
                        setsub8(AL,temp);
                        AL-=temp;
                        cycles-=4;
                        break;
                        case 0x2D: /*SUB AX,#16*/
//                        printf("INS %i\n",ins);
//                        output=1;
                        tempw=getword();
                        setsub16(AX,tempw);
                        AX-=tempw;
                        cycles-=4;
                        break;
                        case 0x2E: /*CS:*/
                        oldss=ss;
                        oldds=ds;
                        ds=ss=cs;
                        ssegs=2;
                        cycles-=4;
                        break;
                        case 0x2F: /*DAS*/
                        if ((flags&A_FLAG)||((AL&0xF)>9))
                        {
                                AL-=6;
                                flags|=A_FLAG;
                        }
                        else
                           flags&=~A_FLAG;
                        if ((flags&C_FLAG)||(AL>0x9F))
                        {
                                AL-=0x60;
                                flags|=C_FLAG;
                        }
                        else
                           flags&=~C_FLAG;
                        setznp8(AL);
                        cycles-=4;
                        break;
                        case 0x30: /*XOR 8,reg*/
                        fetchea();
                        temp=geteab();
                        temp^=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteab(temp);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x31: /*XOR 16,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw^=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        seteaw(tempw);
                        cycles-=((mod==3)?3:24);
                        break;
                        case 0x32: /*XOR reg,8*/
                        fetchea();
                        temp=geteab();
                        temp^=getr8(reg);
                        setznp8(temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        setr8(reg,temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x33: /*XOR reg,16*/
                        fetchea();
                        tempw=geteaw();
                        tempw^=regs[reg].w;
                        setznp16(tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        regs[reg].w=tempw;
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x34: /*XOR AL,#8*/
                        AL^=readmemb(cs+pc); pc++;
                        setznp8(AL);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;
                        case 0x35: /*XOR AX,#16*/
                        AX^=getword();
                        setznp16(AX);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=4;
                        break;

                        case 0x36: /*SS:*/
                        oldss=ss;
                        oldds=ds;
                        ds=ss=ss;
                        ssegs=2;
                        cycles-=4;
                        break;

                        case 0x37: /*AAA*/
                        if ((flags&A_FLAG)||((AL&0xF)>9))
                        {
                                AL+=6;
                                AH++;
                                flags|=(A_FLAG|C_FLAG);
                        }
                        else
                           flags&=~(A_FLAG|C_FLAG);
                        AL&=0xF;
                        cycles-=8;
                        break;

                        case 0x38: /*CMP 8,reg*/
                        fetchea();
                        temp=geteab();
//                        if (output) printf("CMP %02X-%02X\n",temp,getr8(reg));
                        setsub8(temp,getr8(reg));
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x39: /*CMP 16,reg*/
                        fetchea();
                        tempw=geteaw();
//                        if (output) printf("CMP %04X-%04X\n",tempw,regs[reg].w);
                        setsub16(tempw,regs[reg].w);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x3A: /*CMP reg,8*/
                        fetchea();
                        temp=geteab();
//                        if (output) printf("CMP %02X-%02X\n",getr8(reg),temp);
                        setsub8(getr8(reg),temp);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x3B: /*CMP reg,16*/
                        fetchea();
                        tempw=geteaw();
//                        printf("CMP %04X-%04X\n",regs[reg].w,tempw);
                        setsub16(regs[reg].w,tempw);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x3C: /*CMP AL,#8*/
                        temp=readmemb(cs+pc); pc++;
                        setsub8(AL,temp);
                        cycles-=4;
                        break;
                        case 0x3D: /*CMP AX,#16*/
                        tempw=getword();
                        setsub16(AX,tempw);
                        cycles-=4;
                        break;

                        case 0x3E: /*DS:*/
                        oldss=ss;
                        oldds=ds;
                        ds=ss=ds;
                        ssegs=2;
                        cycles-=4;
                        break;

                        case 0x3F: /*AAS*/
                        if ((flags&A_FLAG)||((AL&0xF)>9))
                        {
                                AL-=6;
                                AH--;
                                flags|=(A_FLAG|C_FLAG);
                        }
                        else
                           flags&=~(A_FLAG|C_FLAG);
                        AL&=0xF;
                        cycles-=8;
                        break;

                        case 0x40: case 0x41: case 0x42: case 0x43: /*INC r16*/
                        case 0x44: case 0x45: case 0x46: case 0x47:
                        setadd16nc(regs[opcode&7].w,1);
                        regs[opcode&7].w++;
//                        setznp16(regs[opcode&7].w);
                        cycles-=3;
                        break;
                        case 0x48: case 0x49: case 0x4A: case 0x4B: /*DEC r16*/
                        case 0x4C: case 0x4D: case 0x4E: case 0x4F:
                        setsub16nc(regs[opcode&7].w,1);
                        regs[opcode&7].w--;
//                        setznp16(regs[opcode&7].w);
                        cycles-=3;
                        break;

                        case 0x50: case 0x51: case 0x52: case 0x53: /*PUSH r16*/
                        case 0x54: case 0x55: case 0x56: case 0x57:
                        if (ssegs) ss=oldss;
                        SP-=2;
                        writememw(ss,SP,regs[opcode&7].w);
                        cycles-=15;
                        break;
                        case 0x58: case 0x59: case 0x5A: case 0x5B: /*POP r16*/
                        case 0x5C: case 0x5D: case 0x5E: case 0x5F:
                        if (ssegs) ss=oldss;
                        regs[opcode&7].w=readmemw(ss,SP);
                        SP+=2;
                        cycles-=12;
                        break;
                        /*All the below instructions are 186 instructions, since we emulate an
                          8086/8088, none of these are required*/
#if 0
                        case 0x60: /*PUSHA*/
                        writememw(ss,((SP-2)&0xFFFF),AX);
                        writememw(ss,((SP-4)&0xFFFF),CX);
                        writememw(ss,((SP-6)&0xFFFF),DX);
                        writememw(ss,((SP-8)&0xFFFF),BX);
                        writememw(ss,((SP-10)&0xFFFF),SP);
                        writememw(ss,((SP-12)&0xFFFF),BP);
                        writememw(ss,((SP-14)&0xFFFF),SI);
                        writememw(ss,((SP-16)&0xFFFF),DI);
                        SP-=16;
                        cycles-=16;
                        break;
                        case 0x61: /*POP*/
                        DI=readmemw(ss,((SP)&0xFFFF));
                        SI=readmemw(ss,((SP+2)&0xFFFF));
                        BP=readmemw(ss,((SP+4)&0xFFFF));
                        BX=readmemw(ss,((SP+8)&0xFFFF));
                        DX=readmemw(ss,((SP+10)&0xFFFF));
                        CX=readmemw(ss,((SP+12)&0xFFFF));
                        AX=readmemw(ss,((SP+14)&0xFFFF));
                        SP+=16;
                        cycles-=16;
                        break;
//                        case 0x66: /*BIOS trap*/
//                        callbios();
//                        cycles-=16;
//                        break;

                        case 0x68: /*PUSH #w*/
                        tempw=getword();
                        writememw(ss+((SP-2)&0xFFFF),tempw);
                        SP-=2;
                        cycles-=3;
                        break;
                        case 0x69: /*IMUL r16*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=getword();
                        templ=((int)(signed short)tempw)*((int)(signed short)tempw2);
//                        printf("%04X*%04X = %08X\n",tempw,tempw2,templ);
                        if ((templ>>16)!=0 && (templ>>16)!=0xFFFF) flags|=C_FLAG|V_FLAG;
                        else                                       flags&=~(C_FLAG|V_FLAG);
                        regs[reg].w=templ&0xFFFF;
//                        seteaw(templ&0xFFFF);
                        cycles-=20;
                        break;
                        case 0x6A: /*PUSH #eb*/
                        tempw=readmemb(cs+pc); pc++;
                        if (tempw&0x80) tempw|=0xFF00;
                        writememw(ss+((SP-2)&0xFFFF),tempw);
                        SP-=2;
                        cycles-=3;
                        break;
//                        #if 0
                        case 0x6B: /*IMUL r8*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=readmemb(cs+pc); pc++;
                        if (tempw2&0x80) tempw2|=0xFF00;
//                        printf("%04X * %04X = ",tempw,tempw2);
                        templ=((int)(signed short)tempw)*((int)(signed short)tempw2);
//                        printf("%08X\n",templ);
                        if ((templ>>16)!=0 && (templ>>16)!=0xFFFF) flags|=C_FLAG|V_FLAG;
                        else                                       flags&=~(C_FLAG|V_FLAG);
                        regs[reg].w=templ&0xFFFF;
//                        seteaw(templ&0xFFFF);
                        cycles-=20;
                        break;
#endif
                        case 0x6C: /*INSB*/
                        temp=inb(DX);
                        writememb(es+DI,temp);
                        if (flags&D_FLAG) DI--;
                        else              DI++;
                        cycles-=6;
                        break;
                        case 0x6E: /*OUTSB*/
                        temp=readmemb(ds+SI);
                        if (flags&D_FLAG) SI--;
                        else              SI++;
                        outb(DX,temp);
                        cycles-=6;
                        break;
//                        #endif

                        case 0x70: /*JO*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&V_FLAG) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x71: /*JNO*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&V_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x72: /*JB*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&C_FLAG) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x73: /*JNB*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&C_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x74: /*JZ*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&Z_FLAG) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x75: /*JNZ*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&Z_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x76: /*JBE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&(C_FLAG|Z_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x77: /*JNBE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&(C_FLAG|Z_FLAG))) { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x78: /*JS*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&N_FLAG)  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x79: /*JNS*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&N_FLAG))  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7A: /*JP*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (flags&P_FLAG)  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7B: /*JNP*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!(flags&P_FLAG))  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7C: /*JL*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        temp=(flags&N_FLAG)?1:0;
                        temp2=(flags&V_FLAG)?1:0;
                        if (temp!=temp2)  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7D: /*JNL*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        temp=(flags&N_FLAG)?1:0;
                        temp2=(flags&V_FLAG)?1:0;
                        if (temp==temp2)  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7E: /*JLE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        temp=(flags&N_FLAG)?1:0;
                        temp2=(flags&V_FLAG)?1:0;
                        if ((flags&Z_FLAG) || (temp!=temp2))  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;
                        case 0x7F: /*JNLE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        temp=(flags&N_FLAG)?1:0;
                        temp2=(flags&V_FLAG)?1:0;
                        if (!((flags&Z_FLAG) || (temp!=temp2)))  { pc+=offset; cycles-=12; }
                        cycles-=4;
                        break;

                        case 0x80: case 0x82:
                        fetchea();
                        temp=geteab();
                        temp2=readmemb(cs+pc); pc++;
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ADD b,#8*/
                                setadd8(temp,temp2);
                                seteab(temp+temp2);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x08: /*OR b,#8*/
                                temp|=temp2;
                                setznp8(temp);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteab(temp);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x10: /*ADC b,#8*/
//                                temp2+=(flags&C_FLAG);
                                setadc8(temp,temp2);
                                seteab(temp+temp2+tempc);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x18: /*SBB b,#8*/
//                                temp2+=(flags&C_FLAG);
                                setsbc8(temp,temp2);
                                seteab(temp-(temp2+tempc));
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x20: /*AND b,#8*/
                                temp&=temp2;
                                setznp8(temp);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteab(temp);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x28: /*SUB b,#8*/
                                setsub8(temp,temp2);
                                seteab(temp-temp2);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x30: /*XOR b,#8*/
                                temp^=temp2;
                                setznp8(temp);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteab(temp);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x38: /*CMP b,#8*/
//                                printf("CMP %02X,%02X\n",temp,temp2);
//                                if (output) printf("83CMP %02X-%02X\n",temp,temp2);
                                setsub8(temp,temp2);
                                cycles-=((mod==3)?4:14);
                                break;

                                default:
                                printf("Bad 80 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0x81:
                        fetchea();
                        tempw=geteaw();
                        tempw2=getword();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ADD w,#16*/
                                setadd16(tempw,tempw2);
                                tempw+=tempw2;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x08: /*OR w,#16*/
                                tempw|=tempw2;
                                setznp16(tempw);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x10: /*ADC w,#16*/
//                                tempw2+=(flags&C_FLAG);
                                setadd16(tempw,tempw2);
                                tempw+=tempw2+tempc;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x20: /*AND w,#16*/
                                tempw&=tempw2;
                                setznp16(tempw);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x18: /*SBB w,#16*/
//                                tempw2+=(flags&C_FLAG);
                                setsbc16(tempw,tempw2);
                                seteaw(tempw-(tempw2+tempc));
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x28: /*SUB w,#16*/
                                setsub16(tempw,tempw2);
                                tempw-=tempw2;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x30: /*XOR w,#16*/
                                tempw^=tempw2;
                                setznp16(tempw);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x38: /*CMP w,#16*/
//                                printf("CMP %04X %04X\n",tempw,tempw2);
                                setsub16(tempw,tempw2);
                                cycles-=8;
                                break;

                                default:
                                printf("Bad 81 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0x83:
                        fetchea();
                        tempw=geteaw();
                        tempw2=readmemb(cs+pc); pc++;
                        if (tempw2&0x80) tempw2|=0xFF00;
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ADD w,#8*/
                                setadd16(tempw,tempw2);
                                tempw+=tempw2;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x08: /*OR w,#8*/
                                tempw|=tempw2;
                                setznp16(tempw);
                                seteaw(tempw);
                                flags&=~(C_FLAG|A_FLAG|V_FLAG);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x10: /*ADC w,#8*/
//                                tempw2+=(flags&C_FLAG);
                                setadd16(tempw,tempw2);
                                tempw+=tempw2+tempc;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x18: /*SBB w,#8*/
//                                tempw2+=(flags&C_FLAG);
                                setsbc16(tempw,tempw2);
                                tempw-=(tempw2+tempc);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x20: /*AND w,#8*/
                                tempw&=tempw2;
                                setznp16(tempw);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                flags&=~(C_FLAG|A_FLAG|V_FLAG);
                                break;
                                case 0x28: /*SUB w,#8*/
                                setsub16(tempw,tempw2);
                                tempw-=tempw2;
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                break;
                                case 0x30: /*XOR w,#8*/
                                tempw^=tempw2;
                                setznp16(tempw);
                                seteaw(tempw);
                                cycles-=((mod==3)?4:23);
                                flags&=~(C_FLAG|A_FLAG|V_FLAG);
                                break;
                                case 0x38: /*CMP w,#8*/
                                setsub16(tempw,tempw2);
                                cycles-=8;
                                break;

                                default:
                                printf("Bad 83 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0x84: /*TEST b,reg*/
                        fetchea();
                        temp=geteab();
                        temp2=getr8(reg);
                        setznp8(temp&temp2);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x85: /*TEST w,reg*/
                        fetchea();
                        tempw=geteaw();
                        tempw2=regs[reg].w;
                        setznp16(tempw&tempw2);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=((mod==3)?3:13);
                        break;
                        case 0x86: /*XCHG b,reg*/
                        fetchea();
                        temp=geteab();
                        seteab(getr8(reg));
                        setr8(reg,temp);
                        cycles-=((mod==3)?4:25);
                        break;
                        case 0x87: /*XCHG w,reg*/
                        fetchea();
                        tempw=geteaw();
                        seteaw(regs[reg].w);
                        regs[reg].w=tempw;
                        cycles-=((mod==3)?4:25);
                        break;

                        case 0x88: /*MOV b,reg*/
                        fetchea();
                        seteab(getr8(reg));
                        cycles-=((mod==3)?2:13);
                        break;
                        case 0x89: /*MOV w,reg*/
                        fetchea();
                        seteaw(regs[reg].w);
                        cycles-=((mod==3)?2:13);
                        break;
                        case 0x8A: /*MOV reg,b*/
                        fetchea();
                        temp=geteab();
                        setr8(reg,temp);
                        cycles-=((mod==3)?2:12);
                        break;
                        case 0x8B: /*MOV reg,w*/
                        fetchea();
                        tempw=geteaw();
                        regs[reg].w=tempw;
                        cycles-=((mod==3)?2:12);
                        break;

                        case 0x8C: /*MOV w,sreg*/
                        fetchea();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ES*/
                                seteaw(ES);
                                break;
                                case 0x08: /*CS*/
                                seteaw(CS);
                                break;
                                case 0x18: /*DS*/
                                if (ssegs) ds=oldds;
                                seteaw(DS);
                                break;
                                case 0x10: /*SS*/
                                if (ssegs) ss=oldss;
                                seteaw(SS);
                                break;
                        }
                        cycles-=((mod==3)?2:13);
                        break;

                        case 0x8D: /*LEA*/
                        fetchea();
                        regs[reg].w=eaaddr;
                        cycles-=2;
                        break;

                        case 0x8E: /*MOV sreg,w*/
//                        if (output) printf("MOV %04X  ",pc);
                        fetchea();
//                        if (output) printf("%04X %02X\n",pc,rmdat);
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ES*/
                                tempw=geteaw();
                                templ=loadseg(tempw);
                                if (templ!=0xFFFFFFFF)
                                {
                                        es=templ;
//                                        ES=tempw;
                                }
                                break;
                                case 0x18: /*DS*/
                                tempw=geteaw();
                                templ=loadseg(tempw);
                                if (templ!=0xFFFFFFFF)
                                {
                                        ds=templ;
//                                        DS=tempw;
                                }
                                if (ssegs) oldds=ds;
//                                printf("DS now %04X %04X %04X:%04X\n",ds,tempw,cs>>4,pc);
//                                if (ds==0xA0000) output=1;
                                break;
                                case 0x10: /*SS*/
                                tempw=geteaw();
                                templ=loadseg(tempw);
                                if (templ!=0xFFFFFFFF)
                                {
                                        ss=templ;
//                                        SS=tempw;
                                }
                                if (ssegs) oldss=ss;
                                skipnextprint=1;
				noint=1;
//				printf("SS loaded with %04X %04X:%04X %04X %04X %04X\n",ss>>4,cs>>4,pc,CX,DX,es>>4);
                                break;
                        }
                        cycles-=((mod==3)?2:12);
                        break;

                        case 0x8F: /*POPW*/
                        fetchea();
                        if (ssegs) ss=oldss;
                        tempw=readmemw(ss,SP);
                        SP+=2;
                        seteaw(tempw);
                        cycles-=((mod==3)?12:25);
                        break;

                        case 0x90: /*NOP*/
                        cycles-=3;
                        break;

                        case 0x91: case 0x92: case 0x93: /*XCHG AX*/
                        case 0x94: case 0x95: case 0x96: case 0x97:
                        tempw=AX;
                        AX=regs[opcode&7].w;
                        regs[opcode&7].w=tempw;
                        cycles-=3;
                        break;

                        case 0x98: /*CBW*/
                        AH=(AL&0x80)?0xFF:0;
                        cycles-=2;
                        break;
                        case 0x99: /*CWD*/
                        DX=(AX&0x8000)?0xFFFF:0;
                        cycles-=5;
                        break;
                        case 0x9A: /*CALL FAR*/
                        tempw=getword();
                        tempw2=getword();
                        if (ssegs) ss=oldss;
                        writememw(ss,(SP-2)&0xFFFF,cs>>4);
                        writememw(ss,(SP-4)&0xFFFF,pc);
                        SP-=4;
                        pc=tempw;
                        cs=tempw2<<4;
                        cycles-=36;
                        break;
                        case 0x9B: /*WAIT*/
                        cycles-=4;
                        break;
                        case 0x9C: /*PUSHF*/
//                        printf("PUSHF %04X:%04X\n",CS,pc);
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),flags|0xF000);
                        SP-=2;
                        cycles-=14;
                        break;
                        case 0x9D: /*POPF*/
//                        printf("POPF %04X:%04X\n",CS,pc);
/*                        if (CS==0xFFFF)
                        {
                                dumpregs();
                                exit(-1);
                        }*/
                        if (ssegs) ss=oldss;
                        flags=readmemw(ss,SP)&0xFFF;
                        SP+=2;
                        cycles-=12;
                        break;
                        case 0x9E: /*SAHF*/
                        flags=(flags&0xFF00)|AH;
                        cycles-=4;
                        break;
                        case 0x9F: /*LAHF*/
                        AH=flags&0xFF;
                        cycles-=4;
                        break;

                        case 0xA0: /*MOV AL,(w)*/
                        addr=getword();
                        AL=readmemb(ds+addr);
                        cycles-=14;
                        break;
                        case 0xA1: /*MOV AX,(w)*/
                        addr=getword();
//                        printf("Reading AX from %05X %04X:%04X\n",ds+addr,ds>>4,addr);
                        AX=readmemw(ds,addr);
                        cycles-=14;
                        break;
                        case 0xA2: /*MOV (w),AL*/
                        addr=getword();
                        writememb(ds+addr,AL);
                        cycles-=14;
                        break;
                        case 0xA3: /*MOV (w),AX*/
                        addr=getword();
//                        if (!addr) printf("Write !addr %04X:%04X\n",cs>>4,pc);
                        writememw(ds,addr,AX);
                        cycles-=14;
                        break;

                        case 0xA4: /*MOVSB*/
                        temp=readmemb(ds+SI);
                        writememb(es+DI,temp);
                        if (flags&D_FLAG) { DI--; SI--; }
                        else              { DI++; SI++; }
                        cycles-=18;
                        break;
                        case 0xA5: /*MOVSW*/
                        tempw=readmemw(ds,SI);
                        writememw(es,DI,tempw);
                        if (flags&D_FLAG) { DI-=2; SI-=2; }
                        else              { DI+=2; SI+=2; }
                        cycles-=18;
                        break;
                        case 0xA6: /*CMPSB*/
                        temp =readmemb(ds+SI);
                        temp2=readmemb(es+DI);
                        setsub8(temp,temp2);
                        if (flags&D_FLAG) { DI--; SI--; }
                        else              { DI++; SI++; }
                        cycles-=30;
                        break;
                        case 0xA7: /*CMPSW*/
                        tempw =readmemw(ds,SI);
                        tempw2=readmemw(es,DI);
//                        printf("CMPSW %04X %04X\n",tempw,tempw2);
                        setsub16(tempw,tempw2);
                        if (flags&D_FLAG) { DI-=2; SI-=2; }
                        else              { DI+=2; SI+=2; }
                        cycles-=30;
                        break;
                        case 0xA8: /*TEST AL,#8*/
                        temp=readmemb(cs+pc); pc++;
                        setznp8(AL&temp);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=5;
                        break;
                        case 0xA9: /*TEST AX,#16*/
                        tempw=getword();
                        setznp16(AX&tempw);
                        flags&=~(C_FLAG|V_FLAG|A_FLAG);
                        cycles-=5;
                        break;
                        case 0xAA: /*STOSB*/
                        writememb(es+DI,AL);
                        if (flags&D_FLAG) DI--;
                        else              DI++;
                        cycles-=11;
                        break;
                        case 0xAB: /*STOSW*/
                        writememw(es,DI,AX);
                        if (flags&D_FLAG) DI-=2;
                        else              DI+=2;
                        cycles-=11;
                        break;
                        case 0xAC: /*LODSB*/
                        AL=readmemb(ds+SI);
//                        printf("LODSB %04X:%04X %02X %04X:%04X\n",cs>>4,pc,AL,ds>>4,SI);
                        if (flags&D_FLAG) SI--;
                        else              SI++;
                        cycles-=16;
                        break;
                        case 0xAD: /*LODSW*/
//                        if (times) printf("LODSW %04X:%04X\n",cs>>4,pc);
                        AX=readmemw(ds,SI);
                        if (flags&D_FLAG) SI-=2;
                        else              SI+=2;
                        cycles-=16;
                        break;
                        case 0xAE: /*SCASB*/
                        temp=readmemb(es+DI);
                        setsub8(AL,temp);
                        if (flags&D_FLAG) DI--;
                        else              DI++;
                        cycles-=19;
                        break;
                        case 0xAF: /*SCASW*/
                        tempw=readmemw(es,DI);
                        setsub16(AX,tempw);
                        if (flags&D_FLAG) DI-=2;
                        else              DI+=2;
                        cycles-=19;
                        break;

                        case 0xB0: /*MOV AL,#8*/
                        AL=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB1: /*MOV CL,#8*/
                        CL=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB2: /*MOV DL,#8*/
                        DL=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB3: /*MOV BL,#8*/
                        BL=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB4: /*MOV AH,#8*/
                        AH=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB5: /*MOV CH,#8*/
                        CH=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB6: /*MOV DH,#8*/
                        DH=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB7: /*MOV BH,#8*/
                        BH=readmemb(cs+pc),pc++;
                        cycles-=4;
                        break;
                        case 0xB8: case 0xB9: case 0xBA: case 0xBB: /*MOV reg,#16*/
                        case 0xBC: case 0xBD: case 0xBE: case 0xBF:
                        regs[opcode&7].w=getword();
                        cycles-=4;
                        break;

                        case 0xC0:
                        fetchea();
                        c=readmemb(cs+pc); pc++;
                        temp=geteab();
                        cycles-=c;
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL b,CL*/
                                while (c>0)
                                {
                                        temp2=(temp&0x80)?1:0;
                                        temp=(temp<<1)|temp2;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp2) flags|=C_FLAG;
                                else       flags&=~C_FLAG;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x08: /*ROR b,CL*/
                                while (c>0)
                                {
                                        temp2=temp&1;
                                        temp>>=1;
                                        if (temp2) temp|=0x80;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp2) flags|=C_FLAG;
                                else       flags&=~C_FLAG;
                                seteab(temp);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x10: /*RCL b,CL*/
                                while (c>0)
                                {
                                        tempc=(flags&C_FLAG)?1:0;
                                        if (temp&0x80) flags|=C_FLAG;
                                        else           flags&=~C_FLAG;
                                        temp=(temp<<1)|tempc;
                                        c--;
                                        cycles-=4;
                                }
                                seteab(temp);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x18: /*RCR b,CL*/
                                while (c>0)
                                {
                                        tempc=(flags&C_FLAG)?0x80:0;
                                        if (temp&1) flags|=C_FLAG;
                                        else        flags&=~C_FLAG;
                                        temp=(temp>>1)|tempc;
                                        c--;
                                        cycles-=4;
                                }
                                seteab(temp);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x20: case 0x30: /*SHL b,CL*/
                                if ((temp<<(c-1))&0x80) flags|=C_FLAG;
                                else                    flags&=~C_FLAG;
                                temp<<=c;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=(c*4);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;
                                case 0x28: /*SHR b,CL*/
                                if ((temp>>(c-1))&1) flags|=C_FLAG;
                                else                 flags&=~C_FLAG;
                                temp>>=c;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=(c*4);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;
                                case 0x38: /*SAR b,CL*/
                                if ((temp>>(c-1))&1) flags|=C_FLAG;
                                else                 flags&=~C_FLAG;
                                while (c>0)
                                {
                                        temp>>=1;
                                        if (temp&0x40) temp|=0x80;
                                        c--;
                                        cycles-=4;
                                }
                                seteab(temp);
                                setznp8(temp);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad C0 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xC1:
                        fetchea();
                        c=readmemb(cs+pc); pc++;
                        cycles-=c;
                        tempw=geteaw();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL w,CL*/
                                while (c>0)
                                {
                                        temp=(tempw&0x8000)?1:0;
                                        tempw=(tempw<<1)|temp;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp) flags|=C_FLAG;
                                else      flags&=~C_FLAG;
                                seteaw(tempw);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x08: /*ROR w,CL*/
                                while (c>0)
                                {
                                        tempw2=(tempw&1)?0x8000:0;
                                        tempw=(tempw>>1)|tempw2;
                                        c--;
                                        cycles-=4;
                                }
                                if (tempw2) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                seteaw(tempw);
//                                setznp16(tempw);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x10: /*RCL w,CL*/
                                while (c>0)
                                {
                                        tempc=(flags&C_FLAG)?1:0;
                                        if (tempw&0x8000) flags|=C_FLAG;
                                        else              flags&=~C_FLAG;
                                        tempw=(tempw<<1)|tempc;
                                        c--;
                                        cycles-=4;
                                }
                                seteaw(tempw);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x18: /*RCR w,CL*/
                                while (c>0)
                                {
                                        tempc=(flags&C_FLAG)?0x8000:0;
                                        if (tempw&1) flags|=C_FLAG;
                                        else         flags&=~C_FLAG;
                                        tempw=(tempw>>1)|tempc;
                                        c--;
                                        cycles-=4;
                                }
                                seteaw(tempw);
                                cycles-=((mod==3)?8:28);
                                break;

                                case 0x20: case 0x30: /*SHL w,CL*/
                                if ((tempw<<(c-1))&0x8000) flags|=C_FLAG;
                                else                       flags&=~C_FLAG;
                                tempw<<=c;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=(c*4);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                case 0x28:            /*SHR w,CL*/
                                if ((tempw>>(c-1))&1) flags|=C_FLAG;
                                else                  flags&=~C_FLAG;
                                tempw>>=c;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=(c*4);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                case 0x38:            /*SAR w,CL*/
                                tempw2=tempw&0x8000;
                                if ((tempw>>(c-1))&1) flags|=C_FLAG;
                                else                  flags&=~C_FLAG;
                                while (c>0)
                                {
                                        tempw=(tempw>>1)|tempw2;
                                        c--;
                                        cycles-=4;
                                }
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad C1 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xC2: /*RET*/
                        tempw=getword();
                        if (ssegs) ss=oldss;
                        pc=readmemw(ss,SP);
//                        printf("RET to %04X\n",pc);
                        SP+=2+tempw;
                        cycles-=24;
                        break;
                        case 0xC3: /*RET*/
                        if (ssegs) ss=oldss;
                        pc=readmemw(ss,SP);
//                        if (output) printf("RET to %04X %05X\n",pc,ss+SP);
                        SP+=2;
                        cycles-=20;
                        break;
                        case 0xC4: /*LES*/
                        fetchea();
                        regs[reg].w=readmemw(easeg,eaaddr); //geteaw();
                        tempw=readmemw(easeg,(eaaddr+2)&0xFFFF); //geteaw2();
                        templ=loadseg(tempw);
                        if (templ!=0xFFFFFFFF)
                        {
                                es=templ;
//                                ES=tempw;
                        }
//                        es=ES<<4;
                        cycles-=24;
                        break;
                        case 0xC5: /*LDS*/
                        fetchea();
                        regs[reg].w=readmemw(easeg,eaaddr);
                        tempw=readmemw(easeg,(eaaddr+2)&0xFFFF);
                        templ=loadseg(tempw);
                        if (templ!=0xFFFFFFFF)
                        {
                                ds=templ;
//                                DS=tempw;
                        }
//                        ds=DS<<4;
//                        printf("DS now %04X\n",ds>>4);
                        if (ssegs) oldds=ds;
                        cycles-=24;
                        break;
                        case 0xC6: /*MOV b,#8*/
                        fetchea();
                        temp=readmemb(cs+pc); pc++;
                        seteab(temp);
                        cycles-=((mod==3)?4:14);
                        break;
                        case 0xC7: /*MOV w,#16*/
                        fetchea();
                        tempw=getword();
                        seteaw(tempw);
                        cycles-=((mod==3)?4:14);
                        break;
                        case 0xC8: /*ENTER*/
                        tempw=getword();
                        temp=readmemb(cs+pc); pc++;
                        writememw(ss,((SP-2)&0xFFFF),BP); SP-=2;
                        BP=SP;
                        SP-=tempw;
                        for (temp2=0;temp2<temp;temp2++)
                        {
                                tempw=readmemw(ss,(BP)-(temp2*2));
                                writememw(ss,((SP-2)&0xFFFF),tempw); SP-=2;
                        }
                        cycles-=10;
                        break;
                        case 0xC9: /*LEAVE*/
                        SP=BP;
                        BP=readmemw(ss,SP);
                        SP+=2;
                        cycles-=5;
                        break;
                        case 0xCA: /*RETF*/
                        tempw=getword();
                        if (ssegs) ss=oldss;
                        pc=readmemw(ss,SP);
                        cs=readmemw(ss,SP+2)<<4;
//                        cs=CS<<4;
                        SP+=4;
                        SP+=tempw;
                        cycles-=33;
                        break;
                        case 0xCB: /*RETF*/
                        if (ssegs) ss=oldss;
                        pc=readmemw(ss,SP);
                        cs=readmemw(ss,SP+2)<<4;
//                        cs=CS<<4;
                        SP+=4;
                        cycles-=34;
                        break;
                        case 0xCC: /*INT 3*/
                        if (ssegs) ss=oldss;
                        writememw(ss,((SP-2)&0xFFFF),flags|0xF000);
                        writememw(ss,((SP-4)&0xFFFF),cs>>4);
                        writememw(ss,((SP-6)&0xFFFF),pc);
                        SP-=6;
                        addr=3<<2;
                        flags&=~I_FLAG;
                        pc=readmemw(0,addr);
                        cs=readmemw(0,addr+2)<<4;
                        cycles-=72;
                        break;
                        case 0xCD: /*INT*/
                        lastpc=pc;
                        lastcs=cs>>4;
                        temp=readmemb(cs+pc); pc++;
                        output=0;
//                        if (temp==0x13 && AH==3) printf("Write sector %04X:%04X %05X\n",es>>4,BX,es+BX);
                        if (temp==0x13 && AH==2 && DL<2 && FASTDISC)
                        {
                                int13read();
                        }
                        else if (temp==0x13 && AH==3 && DL<2 && FASTDISC)
                        {
                                int13write();
                        }
                        else
                        {
                                if (ssegs) ss=oldss;
                                writememw(ss,((SP-2)&0xFFFF),flags|0xF000);
                                writememw(ss,((SP-4)&0xFFFF),cs>>4);
                                writememw(ss,((SP-6)&0xFFFF),pc);
                                SP-=6;
                                addr=temp<<2;
                                flags&=~I_FLAG;
                                pc=readmemw(0,addr);
                                cs=readmemw(0,addr+2)<<4;
                                if (!pc && !cs)
                                {
                                        printf("Bad int %02X\n",temp);
//                                        dumpregs();
//                                        exit(-1);
                                }
                        }
                        cycles-=71;
                        break;
                        case 0xCF: /*IRET*/
//                        if (inint) printf("IRET %04X %04X:%04X\n",flags,cs>>4,pc,SP);
/*                        if (output)
                        {
                                dumpregs();
                                exit(-1);
                        }*/
//                        if (!inint) output=0;
                        tempw=cs>>4;
                        tempw2=pc;
                        inint=0;
                        if (ssegs) ss=oldss;
                        pc=readmemw(ss,SP);
                        cs=readmemw(ss,((SP+2)&0xFFFF))<<4;
                        flags=readmemw(ss,((SP+4)&0xFFFF))&0xFFF;
                        SP+=6;
                        cycles-=44;
//                        printf("%04X %04X\n",flags,SP);
                        break;
                        case 0xD0:
                        fetchea();
                        temp=geteab();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL b,1*/
                                if (temp&0x80) flags|=C_FLAG;
                                else           flags&=~C_FLAG;
                                temp<<=1;
                                if (flags&C_FLAG) temp|=1;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x08: /*ROR b,1*/
                                if (temp&1) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                temp>>=1;
                                if (flags&C_FLAG) temp|=0x80;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x10: /*RCL b,1*/
                                temp2=flags&C_FLAG;
                                if (temp&0x80) flags|=C_FLAG;
                                else           flags&=~C_FLAG;
                                temp<<=1;
                                if (temp2) temp|=1;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x18: /*RCR b,1*/
                                temp2=flags&C_FLAG;
                                if (temp&1) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                temp>>=1;
                                if (temp2) temp|=0x80;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x20: /*SHL b,1*/
                                if (temp&0x80) flags|=C_FLAG;
                                else           flags&=~C_FLAG;
                                if ((temp^(temp<<1))&0x80) flags|=V_FLAG;
                                else                       flags&=~V_FLAG;
                                temp<<=1;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;
                                case 0x28: /*SHR b,1*/
                                if (temp&1) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                if (temp&0x80) flags|=V_FLAG;
                                else           flags&=~V_FLAG;
                                temp>>=1;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;
                                case 0x38: /*SAR b,1*/
                                if (temp&1) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                if (temp&0x80) flags|=V_FLAG;
                                else           flags&=~V_FLAG;
                                temp>>=1;
                                if (temp&0x40) temp|=0x80;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad D0 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xD1:
                        fetchea();
                        tempw=geteaw();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL w,1*/
                                if (tempw&0x8000) flags|=C_FLAG;
                                else              flags&=~C_FLAG;
                                tempw<<=1;
                                if (flags&C_FLAG) tempw|=1;
                                seteaw(tempw);
//                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x08: /*ROR w,1*/
                                if (tempw&1) flags|=C_FLAG;
                                else         flags&=~C_FLAG;
                                tempw>>=1;
                                if (flags&C_FLAG) tempw|=0x8000;
                                seteaw(tempw);
//                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x10: /*RCL w,1*/
                                temp2=flags&C_FLAG;
                                if (tempw&0x8000) flags|=C_FLAG;
                                else              flags&=~C_FLAG;
                                tempw<<=1;
                                if (temp2) tempw|=1;
                                seteaw(tempw);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x18: /*RCR w,1*/
                                temp2=flags&C_FLAG;
                                if (tempw&1) flags|=C_FLAG;
                                else         flags&=~C_FLAG;
                                tempw>>=1;
                                if (temp2) tempw|=0x8000;
                                seteaw(tempw);
//                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                break;
                                case 0x20: /*SHL w,1*/
                                if (tempw&0x8000) flags|=C_FLAG;
                                else              flags&=~C_FLAG;
                                if ((tempw^(tempw<<1))&0x8000) flags|=V_FLAG;
                                else                           flags&=~V_FLAG;
                                tempw<<=1;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;
                                case 0x28: /*SHR w,1*/
                                if (tempw&1) flags|=C_FLAG;
                                else         flags&=~C_FLAG;
                                if (tempw&0x8000) flags|=V_FLAG;
                                else              flags&=~V_FLAG;
                                tempw>>=1;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;

                                case 0x38: /*SAR w,1*/
                                if (tempw&1) flags|=C_FLAG;
                                else         flags&=~C_FLAG;
                                flags&=~V_FLAG;
                                flags|=A_FLAG;
                                tempw>>=1;
                                if (tempw&0x4000) tempw|=0x8000;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad D1 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xD2:
                        fetchea();
                        temp=geteab();
                        c=CL;
                        cycles-=c;
//                        if (c>7) printf("Shiftb %i %02X\n",rmdat&0x38,c);
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL b,CL*/
                                while (c>0)
                                {
                                        temp2=(temp&0x80)?1:0;
                                        temp=(temp<<1)|temp2;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp2) flags|=C_FLAG;
                                else       flags&=~C_FLAG;
                                seteab(temp);
//                                setznp8(temp);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x08: /*ROR b,CL*/
                                while (c>0)
                                {
                                        temp2=temp&1;
                                        temp>>=1;
                                        if (temp2) temp|=0x80;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp2) flags|=C_FLAG;
                                else       flags&=~C_FLAG;
                                seteab(temp);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x10: /*RCL b,CL*/
//                                printf("RCL %i %02X %02X\n",c,CL,temp);
                                while (c>0)
                                {
                                        templ=flags&C_FLAG;
                                        temp2=temp&0x80;
                                        temp<<=1;
                                        if (temp2) flags|=C_FLAG;
                                        else       flags&=~C_FLAG;
                                        if (templ) temp|=1;
                                        c--;
                                        cycles-=4;
                                }
//                                printf("Now %02X\n",temp);
                                seteab(temp);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x18: /*RCR b,CL*/
                                while (c>0)
                                {
                                        templ=flags&C_FLAG;
                                        temp2=temp&1;
                                        temp>>=1;
                                        if (temp2) flags|=C_FLAG;
                                        else       flags&=~C_FLAG;
                                        if (templ) temp|=0x80;
                                        c--;
                                        cycles-=4;
                                }
//                                if (temp2) flags|=C_FLAG;
//                                else       flags&=~C_FLAG;
                                seteab(temp);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x20: case 0x30: /*SHL b,CL*/
                                if ((temp<<(c-1))&0x80) flags|=C_FLAG;
                                else                    flags&=~C_FLAG;
                                temp<<=c;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=(c*4);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;
                                case 0x28: /*SHR b,CL*/
                                if ((temp>>(c-1))&1) flags|=C_FLAG;
                                else                 flags&=~C_FLAG;
                                temp>>=c;
                                seteab(temp);
                                setznp8(temp);
                                cycles-=(c*4);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;
                                case 0x38: /*SAR b,CL*/
                                if ((temp>>(c-1))&1) flags|=C_FLAG;
                                else                 flags&=~C_FLAG;
                                while (c>0)
                                {
                                        temp>>=1;
                                        if (temp&0x40) temp|=0x80;
                                        c--;
                                        cycles-=4;
                                }
                                seteab(temp);
                                setznp8(temp);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad D2 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xD3:
                        fetchea();
                        tempw=geteaw();
                        c=CL;
                        cycles-=c;
//                        if (c>15) printf("Shiftw %i %02X\n",rmdat&0x38,c);
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*ROL w,CL*/
                                while (c>0)
                                {
                                        temp=(tempw&0x8000)?1:0;
                                        tempw=(tempw<<1)|temp;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp) flags|=C_FLAG;
                                else      flags&=~C_FLAG;
                                seteaw(tempw);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x08: /*ROR w,CL*/
                                while (c>0)
                                {
                                        tempw2=(tempw&1)?0x8000:0;
                                        tempw=(tempw>>1)|tempw2;
                                        c--;
                                        cycles-=4;
                                }
                                if (tempw2) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                seteaw(tempw);
                                cycles-=((mod==3)?2:28);
                                break;
                                case 0x10: /*RCL w,CL*/
                                while (c>0)
                                {
                                        templ=flags&C_FLAG;
                                        if (tempw&0x8000) flags|=C_FLAG;
                                        else              flags&=~C_FLAG;
                                        tempw=(tempw<<1)|templ;
                                        c--;
                                        cycles-=4;
                                }
                                if (temp) flags|=C_FLAG;
                                else      flags&=~C_FLAG;
                                seteaw(tempw);
                                cycles-=((mod==3)?8:28);
                                break;
                                case 0x18: /*RCR w,CL*/
                                while (c>0)
                                {
                                        templ=flags&C_FLAG;
                                        tempw2=(templ&1)?0x8000:0;
                                        if (tempw&1) flags|=C_FLAG;
                                        else         flags&=~C_FLAG;
                                        tempw=(tempw>>1)|tempw2;
                                        c--;
                                        cycles-=4;
                                }
                                if (tempw2) flags|=C_FLAG;
                                else        flags&=~C_FLAG;
                                seteaw(tempw);
                                cycles-=((mod==3)?8:28);
                                break;

                                case 0x20: case 0x30: /*SHL w,CL*/
                                if (c>16)
                                {
                                        tempw=0;
                                        flags&=~C_FLAG;
                                }
                                else
                                {
                                        if ((tempw<<(c-1))&0x8000) flags|=C_FLAG;
                                        else                       flags&=~C_FLAG;
                                        tempw<<=c;
                                }
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=(c*4);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;

                                case 0x28:            /*SHR w,CL*/
                                if ((tempw>>(c-1))&1) flags|=C_FLAG;
                                else                  flags&=~C_FLAG;
                                tempw>>=c;
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=(c*4);
                                cycles-=((mod==3)?2:23);
                                flags|=A_FLAG;
                                break;

                                case 0x38:            /*SAR w,CL*/
                                tempw2=tempw&0x8000;
                                if ((tempw>>(c-1))&1) flags|=C_FLAG;
                                else                  flags&=~C_FLAG;
                                while (c>0)
                                {
                                        tempw=(tempw>>1)|tempw2;
                                        c--;
                                        cycles-=4;
                                }
                                seteaw(tempw);
                                setznp16(tempw);
                                cycles-=((mod==3)?8:28);
                                flags|=A_FLAG;
                                break;

                                default:
                                printf("Bad D3 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xD4: /*AAM*/
                        tempws=readmemb(cs+pc); pc++;
                        AH=AL/tempws;
                        AL%=tempws;
                        setznp168(AX);
                        cycles-=83;
                        break;
                        case 0xD5: /*AAD*/
                        tempws=readmemb(cs+pc); pc++;
                        AL=(AH*tempws)+AL;
                        AH=0;
                        setznp168(AX);
                        cycles-=60;
                        break;
                        case 0xD7: /*XLAT*/
                        addr=BX+AL;
                        AL=readmemb(ds+addr);
                        cycles-=11;
                        break;
                        case 0xD9: case 0xDA: case 0xDB: case 0xDD: /*ESCAPE*/
                        fetchea();
                        geteab();
                        break;

                        case 0xE0: /*LOOPNE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        CX--;
                        if (CX && !(flags&Z_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=6;
                        break;
                        case 0xE1: /*LOOPE*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        CX--;
                        if (CX && (flags&Z_FLAG)) { pc+=offset; cycles-=12; }
                        cycles-=6;
                        break;
                        case 0xE2: /*LOOP*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        CX--;
                        if (CX) { pc+=offset; cycles-=12; }
                        cycles-=5;
                        break;
                        case 0xE3: /*JCXZ*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        if (!CX) { pc+=offset; cycles-=12; }
                        cycles-=6;
                        break;

                        case 0xE4: /*IN AL*/
                        temp=readmemb(cs+pc); pc++;
                        AL=inb(temp);
                        cycles-=14;
                        break;
                        case 0xE5: /*IN AX*/
                        temp=readmemb(cs+pc); pc++;
                        AL=inb(temp);
                        AH=inb(temp+1);
                        cycles-=14;
                        break;
                        case 0xE6: /*OUT AL*/
                        temp=readmemb(cs+pc); pc++;
                        outb(temp,AL);
                        cycles-=14;
                        break;
                        case 0xE7: /*OUT AX*/
                        temp=readmemb(cs+pc); pc++;
                        outb(temp,AL);
                        outb(temp+1,AH);
                        cycles-=14;
                        break;

                        case 0xE8: /*CALL rel 16*/
                        tempw=getword();
                        if (ssegs) ss=oldss;
//                        writememb(ss+((SP-1)&0xFFFF),pc>>8);
                        writememw(ss,((SP-2)&0xFFFF),pc);
                        SP-=2;
                        pc+=tempw;
                        cycles-=23;
                        break;
                        case 0xE9: /*JMP rel 16*/
//                        printf("PC was %04X\n",pc);
                        pc+=getword();
//                        printf("PC now %04X\n",pc);
                        cycles-=15;
                        break;
                        case 0xEA: /*JMP far*/
                        addr=getword();
                        cs=getword()<<4;
                        pc=addr;
//                        cs=loadcs(CS);
//                        cs=CS<<4;
                        cycles-=15;
                        break;
                        case 0xEB: /*JMP rel*/
                        offset=(signed char)readmemb(cs+pc); pc++;
                        pc+=offset;
                        cycles-=15;
                        break;
                        case 0xEC: /*IN AL,DX*/
                        AL=inb(DX);
                        cycles-=12;
                        break;
                        case 0xED: /*IN AX,DX*/
                        AL=inb(DX);
                        AH=inb(DX+1);
                        cycles-=12;
                        break;
                        case 0xEE: /*OUT DX,AL*/
                        outb(DX,AL);
                        cycles-=12;
                        break;
                        case 0xEF: /*OUT DX,AX*/
                        outb(DX,AL);
                        outb(DX+1,AH);
                        cycles-=12;
                        break;

                        case 0xF0: /*LOCK*/
                        cycles-=4;
                        break;

                        case 0xF2: /*REPNE*/
                        rep(0);
                        break;
                        case 0xF3: /*REPE*/
                        rep(1);
                        break;

                        case 0xF4: /*HLT*/
//                        printf("IN HLT!!!! %04X:%04X %08X %08X\n",oldcs,oldpc,old8,old82);
//                        dumpregs();
//                        exit(-1);
                        inhlt=1;
                        pc--;
                        cycles-=2;
                        break;
                        case 0xF5: /*CMC*/
                        flags^=C_FLAG;
                        cycles-=2;
                        break;

                        case 0xF6:
                        fetchea();
                        temp=geteab();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*TEST b,#8*/
                                temp2=readmemb(cs+pc); pc++;
//                                printf("TEST %02X,%02X\n",temp,temp2);
/*                        if (cs==0x700 && !temp && temp2==0x10)
                        {
                                dumpregs();
                                exit(-1);
                        }*/
                                temp&=temp2;
                                setznp8(temp);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                cycles-=((mod==3)?5:11);
                                break;
                                case 0x10: /*NOT b*/
                                temp=~temp;
                                seteab(temp);
                                cycles-=((mod==3)?3:24);
                                break;
                                case 0x18: /*NEG b*/
                                setsub8(0,temp);
                                temp=0-temp;
                                seteab(temp);
                                cycles-=((mod==3)?3:24);
                                break;
                                case 0x20: /*MUL AL,b*/
                                setznp8(AL);
                                AX=AL*temp;
                                if (AX) flags&=~Z_FLAG;
                                else    flags|=Z_FLAG;
                                if (AH) flags|=(C_FLAG|V_FLAG);
                                else    flags&=~(C_FLAG|V_FLAG);
                                cycles-=70;
                                break;
                                case 0x28: /*IMUL AL,b*/
                                setznp8(AL);
                                tempws=(int)((signed char)AL)*(int)((signed char)temp);
                                AX=tempws&0xFFFF;
                                if (AX) flags&=~Z_FLAG;
                                else    flags|=Z_FLAG;
                                if (AH) flags|=(C_FLAG|V_FLAG);
                                else    flags&=~(C_FLAG|V_FLAG);
                                cycles-=80;
                                break;
                                case 0x30: /*DIV AL,b*/
                                tempw=AX;
                                if (temp)
                                {
                                        tempw2=tempw%temp;
/*                                        if (!tempw)
                                        {
                                                writememw((ss+SP)-2,flags|0xF000);
                                                writememw((ss+SP)-4,cs>>4);
                                                writememw((ss+SP)-6,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0);
                                                cs=readmemw(2)<<4;
                                                printf("Div by zero %04X:%04X\n",cs>>4,pc);
//                                                dumpregs();
//                                                exit(-1);
                                        }
                                        else
                                        {*/
                                                AH=tempw2;
                                                tempw/=temp;
                                                AL=tempw&0xFF;
//                                        }
                                }
                                else
                                {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
//                                        printf("Div by zero %04X:%04X %02X %02X\n",cs>>4,pc,0xf6,0x30);
//                                        dumpregs();
//                                        exit(-1);
                                }
                                cycles-=80;
                                break;
                                case 0x38: /*IDIV AL,b*/
                                tempws=(int)AX;
                                if (temp)
                                {
                                        tempw2=tempws%(int)((signed char)temp);
/*                                        if (!tempw)
                                        {
                                                writememw((ss+SP)-2,flags|0xF000);
                                                writememw((ss+SP)-4,cs>>4);
                                                writememw((ss+SP)-6,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0);
                                                cs=readmemw(2)<<4;
                                                printf("Div by zero %04X:%04X\n",cs>>4,pc);
                                        }
                                        else
                                        {*/
                                                AH=tempw2&0xFF;
                                                tempws/=(int)((signed char)temp);
                                                AL=tempws&0xFF;
//                                        }
                                }
                                else
                                {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
//                                        printf("Div by zero %04X:%04X %02X %02X\n",cs>>4,pc,0xf6,0x38);
                                }
                                cycles-=101;
                                break;

                                default:
                                printf("Bad F6 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xF7:
                        fetchea();
                        tempw=geteaw();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*TEST w*/
                                tempw2=getword();
                                setznp16(tempw&tempw2);
                                flags&=~(C_FLAG|V_FLAG|A_FLAG);
                                cycles-=((mod==3)?5:11);
                                break;
                                case 0x10: /*NOT w*/
                                seteaw(~tempw);
                                cycles-=((mod==3)?3:24);
                                break;
                                case 0x18: /*NEG w*/
                                setsub16(0,tempw);
                                tempw=0-tempw;
                                seteaw(tempw);
                                cycles-=((mod==3)?3:24);
                                break;
                                case 0x20: /*MUL AX,w*/
                                setznp16(AX);
                                templ=AX*tempw;
                                AX=templ&0xFFFF;
                                DX=templ>>16;
                                if (AX|DX) flags&=~Z_FLAG;
                                else       flags|=Z_FLAG;
                                if (DX)    flags|=(C_FLAG|V_FLAG);
                                else       flags&=~(C_FLAG|V_FLAG);
                                cycles-=118;
                                break;
                                case 0x28: /*IMUL AX,w*/
                                setznp16(AX);
//                                printf("IMUL %i %i ",(int)((signed short)AX),(int)((signed short)tempw));
                                tempws=(int)((signed short)AX)*(int)((signed short)tempw);
                                if ((tempws>>15) && ((tempws>>15)!=-1)) flags|=(C_FLAG|V_FLAG);
                                else                                    flags&=~(C_FLAG|V_FLAG);
//                                printf("%i ",tempws);
                                AX=tempws&0xFFFF;
                                tempws=(unsigned short)(tempws>>16);
                                DX=tempws&0xFFFF;
//                                printf("%04X %04X\n",AX,DX);
//                                dumpregs();
//                                exit(-1);
                                if (AX|DX) flags&=~Z_FLAG;
                                else       flags|=Z_FLAG;
                                cycles-=128;
                                break;
                                case 0x30: /*DIV AX,w*/
                                templ=(DX<<16)|AX;
//                                printf("DIV %08X/%04X\n",templ,tempw);
                                if (tempw)
                                {
                                        tempw2=templ%tempw;
                                        if (!tempw)
                                        {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
                                                printf("Div by zero %04X:%04X %02X %02X 0\n",cs>>4,pc,0xf7,0x30);
//                                                dumpregs();
//                                                exit(-1);
                                        }
                                        else
                                        {
                                                DX=tempw2;
                                                templ/=tempw;
                                                AX=templ&0xFFFF;
                                        }
                                }
                                else
                                {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
//                                        printf("Div by zero %04X:%04X %02X %02X 1\n",cs>>4,pc,0xf7,0x30);
                                }
                                cycles-=144;
                                break;
                                case 0x38: /*IDIV AX,w*/
                                tempws=(int)((DX<<16)|AX);
//                                printf("IDIV %i %i ",tempws,tempw);
                                if (tempw)
                                {
                                        tempw2=tempws%(int)((signed short)tempw);
//                                        printf("%04X ",tempw2);
                                        if (!tempw)
                                        {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
//                                                printf("Div by zero %04X:%04X %02X %02X 0\n",cs>>4,pc,0xf7,0x38);
                                        }
                                        else
                                        {
                                                DX=tempw2;
                                                tempws/=(int)((signed short)tempw);
                                                AX=tempws&0xFFFF;
//                                                printf("%04X %i\n",AX,tempws);
//                                                dumpregs();
//                                                exit(-1);
                                        }
                                }
                                else
                                {
//                                        printf("%04X:%04X\n",cs>>4,pc);
                                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                                writememw(ss,(SP-4)&0xFFFF,CS);
                                                writememw(ss,(SP-6)&0xFFFF,pc);
                                                SP-=6;
                                                flags&=~I_FLAG;
                                                pc=readmemw(0,0);
                                                cs=readmemw(0,2)<<4;
//                                                cs=loadcs(CS);
//                                                cs=CS<<4;
//                                        printf("Div by zero %04X:%04X %02X %02X 1\n",cs>>4,pc,0xf7,0x38);
                                }
                                cycles-=165;
                                break;

                                default:
                                printf("Bad F7 opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        case 0xF8: /*CLC*/
                        flags&=~C_FLAG;
                        cycles-=2;
                        break;
                        case 0xF9: /*STC*/
//                        printf("STC %04X\n",pc);
                        flags|=C_FLAG;
                        cycles-=2;
                        break;
                        case 0xFA: /*CLI*/
                        flags&=~I_FLAG;
//                        printf("CLI at %04X:%04X\n",cs>>4,pc);
                        cycles-=3;
                        break;
                        case 0xFB: /*STI*/
                        flags|=I_FLAG;
//                        printf("STI at %04X:%04X\n",cs>>4,pc);
                        cycles-=2;
                        break;
                        case 0xFC: /*CLD*/
                        flags&=~D_FLAG;
                        cycles-=2;
                        break;
                        case 0xFD: /*STD*/
                        flags|=D_FLAG;
                        cycles-=2;
                        break;

                        case 0xFE: /*INC/DEC b*/
                        fetchea();
                        temp=geteab();
                        flags&=~V_FLAG;
                        if (rmdat&0x38)
                        {
                                setsub8nc(temp,1);
                                temp2=temp-1;
                                if ((temp&0x80) && !(temp2&0x80)) flags|=V_FLAG;
                        }
                        else
                        {
                                setadd8nc(temp,1);
                                temp2=temp+1;
                                if ((temp2&0x80) && !(temp&0x80)) flags|=V_FLAG;
                        }
//                        setznp8(temp2);
                        seteab(temp2);
                        cycles-=((mod==3)?3:23);
                        break;

                        case 0xFF:
                        fetchea();
                        switch (rmdat&0x38)
                        {
                                case 0x00: /*INC w*/
                                tempw=geteaw();
//                                setadd16(tempw,1);
                                setznp16(tempw+1);
                                seteaw(tempw+1);
                                cycles-=((mod==3)?3:23);
                                break;
                                case 0x08: /*DEC w*/
                                tempw=geteaw();
//                                setsub16(tempw,1);
                                setznp16(tempw-1);
                                seteaw(tempw-1);
                                cycles-=((mod==3)?3:23);
                                break;
                                case 0x10: /*CALL*/
                                tempw=geteaw();
                                if (ssegs) ss=oldss;
                                writememw(ss,(SP-2)&0xFFFF,pc);
                                SP-=2;
                                pc=tempw;
                                cycles-=((mod==3)?20:29);
                                break;
                                case 0x18: /*CALL far*/
                                tempw=readmemw(easeg,eaaddr);
                                tempw2=readmemw(easeg,(eaaddr+2)&0xFFFF); //geteaw2();
//                                tempw3=CS;
//                                tempw4=pc;
//                                templ=loadcs(tempw2);
//                                if (templ!=0xFFFFFFFF)
//                                {
//                                        cs=loadcs(CS);
                                        if (ssegs) ss=oldss;
                                        writememw(ss,(SP-2)&0xFFFF,cs>>4);
                                        writememw(ss,((SP-4)&0xFFFF),pc);
                                        SP-=4;
                                        cs=tempw2<<4;
                                        pc=tempw;
//                                }
                                cycles-=53;
                                break;
                                case 0x20: /*JMP*/
                                pc=geteaw();
                                cycles-=((mod==3)?11:18);
                                break;
                                case 0x28: /*JMP far*/
                                pc=readmemw(easeg,eaaddr); //geteaw();
                                cs=readmemw(easeg,(eaaddr+2)&0xFFFF)<<4; //geteaw2();
//                                cs=loadcs(CS);
//                                cs=CS<<4;
                                cycles-=24;
                                break;
                                case 0x30: /*PUSH w*/
                                tempw=geteaw();
//                                if (output) printf("PUSH %04X %i %02X %04X %04X %02X %02X\n",tempw,rm,rmdat,easeg,eaaddr,ram[0x22340+0x5638],ram[0x22340+0x5639]);
                                if (ssegs) ss=oldss;
                                writememw(ss,((SP-2)&0xFFFF),tempw);
                                SP-=2;
                                cycles-=((mod==3)?15:24);
                                break;

                                default:
                                printf("Bad FF opcode %02X\n",rmdat&0x38);
//                                dumpregs();
//                                exit(-1);
                        }
                        break;

                        default:
                        pc--;
                        cycles-=8;
                        break;
                        printf("Bad opcode %02X at %04X:%04X from %04X:%04X %08X\n",opcode,cs>>4,pc,old8>>16,old8&0xFFFF,old82);
                        dumpregs();
                        exit(-1);
                }
//                if (pc==0x370) printf("C370!\n");
//                if (pc==0x37A) printf("C37A!\n");
//                if (pc==0xE107) output=1;
/*                if (!AMSTRAD && (cs+pc)==0xFE3A3)
                {
                        printf("Here! %f\n",pit.c[0]);
                        cycles-=16;
                }*/
//                if (pc==0xD303) printf("D303 %i\n",flags&C_FLAG);
/*        if (ins==3495000) output=1;*/
/*                if (pc==0x1852)
                {
                        printf("1852 from %04X:%04X %04X\n",oldcs,oldpc,AX);
                        dumpregs();
                        exit(-1);
                }*/
//                if (pc==0xE237) printf("E237 from %04X:%04X %04X\n",oldcs,oldpc,AX);
//                if (pc==0xD16A) printf("D16A from %04X:%04X %04X\n",oldcs,oldpc,AX);
//                if (pc==0xE230) printf("E230 - AH %02X DL %02X\n",AH,DL);
//                if (pc==0xD2DE) printf("D2DE %i\n",flags&C_FLAG);
//                if ((cs+pc)==0xFE387) printf("E387 from %04X:%04X\n",oldcs,oldpc);
//                if ((cs+pc)==0xFF975) printf("F975 from %04X:%04X\n",oldcs,oldpc);
//                if ((cs+pc)==0xFF996) printf("F996 from %04X:%04X\n",oldcs,oldpc);
//                if ((cs+pc)==0xFF968) printf("F96C from %04X:%04X\n",oldcs,oldpc);
//                10a 12b
//                if (pc==0xE10A) output=1;
//                if (pc==0xE12B) output=0;
//                if (pc==0xE12B) output=1;
                if (ssegs)
                {
                        ssegs--;
                        if (!ssegs)
                        {
                                ds=oldds;
                                ss=oldss;
                        }
                }
                cycdiff-=cycles;
                if (keyboardtimer)
                {
                        keyboardtimer-=cycdiff;
                        if (keyboardtimer<1)
                        {
                                keyboardtimer=0;
                                keyboardtimeout();
                        }
                }
//                if (ins==2000000) output=1;
//                if (pc==0xD200) printf("D200 %04X\n",CX);
//                if (pc==0xD212) printf("D212 from %04X:%04X\n",oldcs,oldpc);
//                if (pc==0xCA39) printf("CA39 %04X %04X\n",BX,BP);
//                if (pc==0xC9F2) output=1;
//                if (pc==0xCB04) output=0;
/*                if (DL==0x10 && !dlE)
                {
                        printf("DL=0E at %04X:%04X %04X:%04X\n",cs>>4,pc,oldcs,oldpc);
                }
                dlE=(DL==0x10);*/
                if (/*pit0 && */!pit.delay[0]) pit.c[0]-=cycdiff;
                if (!pit.delay[1])         pit.c[1]-=(cycdiff<<1);
                if (!pit.delay[2])         pit.c[2]-=cycdiff;
//                if (pit.delay[0]) pit.delay[0]--;
//                if (pit.delay[1]) pit.delay[1]--;
//                if (pit.delay[2]) pit.delay[2]--;
                if ((pit.c[0]<1)||(pit.c[1]<1)||(pit.c[2]<1)) pollpit();
                spktime-=cycdiff;
                if (spktime<=0.0)
                {
                        spktime+=SPKCONST;
                        pollspk();
                }
                if (disctime)
                {
                        disctime-=(cycdiff/2);
                        if (disctime<=0)
                        {
                                disctime=0;
                                polldisc();
                        }
                }
                if (mousedelay)
                {
                        mousedelay--;
                        if (!mousedelay)
                           mousecallback();
                }
                        
//                if (cs==0 && pc==0x7C00) { ins=0; output=1; }
                if ((flags&I_FLAG) && (pic.pend&~pic.mask) && !ssegs && !noint)
                {
                        temp=picinterrupt();
                        if (temp!=0xFF)
                        {
                                if (temp==8) intcount++;
//                                printf("PIC interrupt %i at %04X:%04X %i %02X ",temp,cs>>4,pc,ins,pic.mask);
//                                output=1;
                                writememw(ss,(SP-2)&0xFFFF,flags|0xF000);
                                writememw(ss,(SP-4)&0xFFFF,cs>>4);
                                writememw(ss,(SP-6)&0xFFFF,pc);
                                SP-=6;
                                addr=temp<<2;
                                flags&=~I_FLAG;
                                pc=readmemw(0,addr);
                                cs=readmemw(0,addr+2)<<4;
//                                printf("%04X %04X:%04X\n",addr,cs>>4,pc);
                                inint=1;
                        }
                }
                if (noint) noint=0;
                ins++;
                if (timetolive)
                {
                        timetolive--;
                        if (!timetolive) output=0;
                }
        }
}
//#endif
